<?php
/**
 * Implementaton of the provaaccess_ipaddress plugin.
 *
 * @package    provaaccess
 * @subpackage ipaddress
 */


defined('MOODLE_INTERNAL') || die();

require_once($CFG->dirroot . '/mod/prova/accessrule/accessrulebase.php');


/**
 * A rule implementing the ipaddress check against the ->subnet setting.
 */
class provaaccess_ipaddress extends prova_access_rule_base {

    public static function make(prova $provaobj, $timenow, $canignoretimelimits) {
        if (empty($provaobj->get_prova()->subnet)) {
            return null;
        }

        return new self($provaobj, $timenow);
    }

    public function prevent_access() {
        if (address_in_subnet(getremoteaddr(), $this->prova->subnet)) {
            return false;
        } else {
            return get_string('subnetwrong', 'provaaccess_ipaddress');
        }
    }
}
