<?php

/**
 * Unit tests for the provaaccess_ipaddress plugin.
 *
 * @package    provaaccess
 * @subpackage ipaddress
 */


defined('MOODLE_INTERNAL') || die();

global $CFG;
require_once($CFG->dirroot . '/mod/prova/accessrule/ipaddress/rule.php');


/**
 * Unit tests for the provaaccess_ipaddress plugin.
 */
class provaaccess_ipaddress_testcase extends basic_testcase {
    public function test_ipaddress_access_rule() {
        $prova = new stdClass();
        $attempt = new stdClass();
        $cm = new stdClass();
        $cm->id = 0;

        // Test the allowed case by getting the user's IP address. However, this
        // does not always work, for example using the mac install package on my laptop.
        $prova->subnet = getremoteaddr(null);
        if (!empty($prova->subnet)) {
            $provaobj = new prova($prova, $cm, null);
            $rule = new provaaccess_ipaddress($provaobj, 0);

            $this->assertFalse($rule->prevent_access());
            $this->assertFalse($rule->description());
            $this->assertFalse($rule->prevent_new_attempt(0, $attempt));
            $this->assertFalse($rule->is_finished(0, $attempt));
            $this->assertFalse($rule->end_time($attempt));
            $this->assertFalse($rule->time_left_display($attempt, 0));
        }

        $prova->subnet = '0.0.0.0';
        $provaobj = new prova($prova, $cm, null);
        $rule = new provaaccess_ipaddress($provaobj, 0);

        $this->assertNotEmpty($rule->prevent_access());
        $this->assertEmpty($rule->description());
        $this->assertFalse($rule->prevent_new_attempt(0, $attempt));
        $this->assertFalse($rule->is_finished(0, $attempt));
        $this->assertFalse($rule->end_time($attempt));
        $this->assertFalse($rule->time_left_display($attempt, 0));
    }
}
