<?php
/**
 * Implementaton of the provaaccess_numattempts plugin.
 *
 * @package    provaaccess
 * @subpackage numattempts
 */


defined('MOODLE_INTERNAL') || die();

require_once($CFG->dirroot . '/mod/prova/accessrule/accessrulebase.php');


/**
 * A rule controlling the number of attempts allowed.
 */
class provaaccess_numattempts extends prova_access_rule_base {

    public static function make(prova $provaobj, $timenow, $canignoretimelimits) {

        if ($provaobj->get_num_attempts_allowed() == 0) {
            return null;
        }

        return new self($provaobj, $timenow);
    }

    public function description() {
        return get_string('attemptsallowedn', 'provaaccess_numattempts', $this->prova->attempts);
    }

    public function prevent_new_attempt($numprevattempts, $lastattempt) {
        if ($numprevattempts >= $this->prova->attempts) {
            return get_string('nomoreattempts', 'prova');
        }
        return false;
    }

    public function is_finished($numprevattempts, $lastattempt) {
        return $numprevattempts >= $this->prova->attempts;
    }
}
