<?php
/**
 * Unit tests for the provaaccess_offlineattempts plugin.
 *
 * @package    provaaccess_offlineattempts
 */


defined('MOODLE_INTERNAL') || die();

global $CFG;
require_once($CFG->dirroot . '/mod/prova/accessrule/offlineattempts/rule.php');


/**
 * Unit tests for the provaaccess_offlineattempts plugin.
 */
class provaaccess_offlineattempts_testcase extends basic_testcase {
    public function test_offlineattempts_access_rule() {
        $prova = new stdClass();
        $prova->allowofflineattempts = 1;
        $cm = new stdClass();
        $cm->id = 0;
        $provaobj = new prova($prova, $cm, null);
        $rule = new provaaccess_offlineattempts($provaobj, 0);
        $attempt = new stdClass();

        $this->assertFalse($rule->prevent_access());
        $this->assertFalse($rule->prevent_new_attempt(0, $attempt));
        $this->assertFalse($rule->is_finished(0, $attempt));
        $this->assertFalse($rule->end_time($attempt));
        $this->assertFalse($rule->time_left_display($attempt, 0));
    }
}
