<?php
/**
 * Unit tests for the provaaccess_password plugin.
 *
 * @package    provaaccess
 * @subpackage password
 * @category   phpunit
 */


defined('MOODLE_INTERNAL') || die();

global $CFG;
require_once($CFG->dirroot . '/mod/prova/accessrule/password/rule.php');


/**
 * Unit tests for the provaaccess_password plugin.
 */
class provaaccess_password_testcase extends basic_testcase {
    public function test_password_access_rule() {
        $prova = new stdClass();
        $prova->password = 'frog';
        $cm = new stdClass();
        $cm->id = 0;
        $provaobj = new prova($prova, $cm, null);
        $rule = new provaaccess_password($provaobj, 0);
        $attempt = new stdClass();

        $this->assertFalse($rule->prevent_access());
        $this->assertEquals($rule->description(),
            get_string('requirepasswordmessage', 'provaaccess_password'));
        $this->assertFalse($rule->prevent_new_attempt(0, $attempt));
        $this->assertFalse($rule->is_finished(0, $attempt));
        $this->assertFalse($rule->end_time($attempt));
        $this->assertFalse($rule->time_left_display($attempt, 0));
    }
}
