<?php
/**
 * Unit tests for the provaaccess_securewindow plugin.
 *
 * @package    provaaccess
 * @subpackage securewindow
 */


defined('MOODLE_INTERNAL') || die();

global $CFG;
require_once($CFG->dirroot . '/mod/prova/accessrule/securewindow/rule.php');


/**
 * Unit tests for the provaaccess_securewindow plugin.
 */
class provaaccess_securewindow_testcase extends basic_testcase {
    public static $includecoverage = array('mod/prova/accessrule/securewindow/rule.php');

    // Nothing very testable in this class, just test that it obeys the general access rule contact.
    public function test_securewindow_access_rule() {
        $prova = new stdClass();
        $prova->browsersecurity = 'securewindow';
        $cm = new stdClass();
        $cm->id = 0;
        $provaobj = new prova($prova, $cm, null);
        $rule = new provaaccess_securewindow($provaobj, 0);
        $attempt = new stdClass();

        $this->assertFalse($rule->prevent_access());
        $this->assertEmpty($rule->description());
        $this->assertFalse($rule->prevent_new_attempt(0, $attempt));
        $this->assertFalse($rule->is_finished(0, $attempt));
        $this->assertFalse($rule->end_time($attempt));
        $this->assertFalse($rule->time_left_display($attempt, 0));
    }
}
