
define(['jquery', 'core/yui'], function($, Y) {
    
    var SELECTORS = {
        SELECT_ROW: '.provarow',
        POS_SELECT_ROW_RADIO: 'td input[name="provaid"]',
        SELECT_ROW_RADIO: '.provarow td input[name="provaid"]',
        CANCELL: 'input[name="cancel"]',
    };

    /**
     * @alias module:mod_prova/preflightcheck
     */
    var t = {
        init: function() {
            $(SELECTORS.SELECT_ROW).on('click', this.handle_table_click);
            $(SELECTORS.CANCELL).on('click', this.skipValidation);
        },
        handle_table_click: function(e) {
            var anchorElement = $(e.currentTarget);
            $(SELECTORS.SELECT_ROW_RADIO).prop('checked', false);
            $(SELECTORS.SELECT_ROW).removeAttr('checked');
            anchorElement.find(SELECTORS.POS_SELECT_ROW_RADIO).prop('checked', true);
            anchorElement.attr('checked','checked');
        },
        skipValidation: function(e) {
            $(SELECTORS.POS_SELECT_ROW_RADIO).removeAttr('required');
        }
    }
    
    return t;
});
