/**
 * Initialise the question bank modal on the quiz page.
 *
 * @module    mod_prova/provabank
 * @package   mod_prova
 */
define(
    [
        'mod_prova/add_prova_modal_launcher',
        'mod_prova/modal_prova_bank'
    ],
    function(
        AddProvaModalLauncher,
        ModalProvaBank
    ) {

    return {
        /**
         * Create the question bank modal.
         *
         * @param  {int} contextId Current context id.
         */
        init: function(contextId, pageurl) {
            AddProvaModalLauncher.init(
                ModalProvaBank.TYPE,
                '.menu [data-action="buscar_prova"]',
                contextId,
                pageurl
            );
        }
    };
});
