<?php
/**
 * Classe responsável por gerar o form de Áre, Subárea e
 * assunto utilizando os padrões do moodle.
 */
namespace mod_prova\form;


/* require_once($CFG->libdir.'/outputcomponents.php'); */

include_once($CFG->libdir.'/formslib.php');

use html_writer;
use single_button;
use moodle_url;

class seox_check_areas_form extends \moodleform {

	private static $filtros_areas_content = array();

    public static $dificuldadeslist = array(
        0 => 'Fácil',
        1 => 'Médio',
        2 => 'Difícil',
    );
 
    public function definition() {

        $mform =& $this->_form;

        $this->render_select_dificuldades($mform);
        $this->render_select_filtros_areas($mform);
        
        $mform->addElement('hidden', 'questionid');
        $mform->setType('questionid', PARAM_INT);
        $mform->addElement('hidden', 'returnurl');
        $mform->setType('returnurl', PARAM_LOCALURL);
        $mform->addElement('hidden', 'update');
        $mform->setType('update', PARAM_BOOL);
        $mform->addElement('hidden', 'seoxid');
        $mform->setType('seoxid', PARAM_INT);
        $mform->addElement('hidden', 'id_area');
        $mform->setType('id_area', PARAM_INT);
        $mform->addElement('hidden', 'id_subarea');
        $mform->setType('id_subarea', PARAM_INT);
        $mform->addElement('hidden', 'id_assunto');
        $mform->setType('id_assunto', PARAM_INT);
        $mform->addElement('hidden', 'dificuldade');
        $mform->setType('dificuldade', PARAM_INT);
        $this->add_action_buttons();
        $mform->disabledIf('submitbutton', 'md_areas', 'eq', 0);
        $mform->disabledIf('submitbutton', 'md_subareas', 'eq', 0);
        $mform->disabledIf('submitbutton', 'md_assuntos', 'eq', 0);

    }

    protected function render_select_dificuldades($mform) {
		$mform->addElement('select', 'md_dificuldades', get_string('addquestions:dificuldades_titles', 'provacomp_addquestions'), self::$dificuldadeslist);
		$mform->addRule('md_dificuldades', null, 'required', null, 'client', false, true);
    }

    protected function render_select_filtros_areas($mform) {

    	$areas = array(0 => '');
    	$subareas = array(0 => '');
    	$assuntos = array(0 => '');

    	$this->get_filtros_areas_content_db($areas, $subareas, $assuntos);

		$mform->addElement('select', 'md_areas', get_string('addquestions:area_titles', 'provacomp_addquestions'), $areas);
		$mform->addRule('md_areas', null, 'required', null, 'client', false, true);

		$mform->addElement('select', 'md_subareas', get_string('addquestions:subarea_titles', 'provacomp_addquestions'), $subareas);
		$mform->addRule('md_subareas', null, 'required', null, 'client', false, true);
    	
		$mform->addElement('select', 'md_assuntos', get_string('addquestions:assunto_titles', 'provacomp_addquestions'), $assuntos);
		$mform->addRule('md_assuntos', null, 'required', null, 'client', false, true);
    }

    protected function get_filtros_areas_content_db(&$root_area, &$root_subarea, &$root_assunto) {
    	global $DB;
    	if ($areas = $DB->get_records('seox_area', array())) {
    		foreach ($areas as $key => $area) {
    			self::$filtros_areas_content['areas'][$area->id] = array(
    				'name' => $area->name,
    				'subareas' => array(),
    			);
    			$root_area[$area->id] = $area->name;
    		}
		}

		$subarea_temp = array();
		if ($areas and $subareas = $DB->get_records('seox_subarea', array())) {
			foreach ($subareas as $key => $subarea) {
    			self::$filtros_areas_content['areas'][$subarea->id_area]['subareas'][$subarea->id] = array(
    				'name' => $subarea->name,
    				'assuntos' => array(),
    			);
    			$subarea_temp[$subarea->id] = $subarea->id_area;
    			$root_subarea[$subarea->id] = $subarea->name;
			}
		}

		if ($areas and $subareas and $assuntos = $DB->get_records('seox_assunto', array())) {
    		foreach ($assuntos as $key => $assunto) {
    			self::$filtros_areas_content['areas'][$subarea_temp[$assunto->id_subarea]]['subareas'][$assunto->id_subarea]['assuntos'][$assunto->id] = array('name' => $assunto->name);
    			$root_assunto[$assunto->id] = $assunto->name;
			}
		}
    }

    public function get_filtros_areas_content() {
    	return self::$filtros_areas_content;
    }

    public function populate_elements($defaults) {
        if (empty($defaults)) { return; }
        $mform =& $this->_form;
        if (array_key_exists('md_areas', $defaults)) {
            $mform->setDefault('md_areas', $defaults['md_areas']);
        }
        if (array_key_exists('md_subareas', $defaults)) {
            $mform->setDefault('md_subareas', $defaults['md_subareas']);
        }
        if (array_key_exists('md_assuntos', $defaults)) {
            $mform->setDefault('md_assuntos', $defaults['md_assuntos']);
        }
        if (array_key_exists('md_dificuldades', $defaults)) {
            $mform->getElement('md_dificuldades')->setSelected($defaults['md_dificuldades']);
        }
        if (array_key_exists('md_name_prova', $defaults)) {
            $mform->setDefault('md_name_prova', $defaults['md_name_prova']);
        }
        if (array_key_exists('md_name_prof', $defaults)) {
            $mform->setDefault('md_name_prof', $defaults['md_name_prof']);
        }
    }

    public function verifyAreas(){
        global $DB;

		$sql = 'SELECT  assunto.id AS s_assunto_id,
                        subarea.id AS s_subarea_id,
                        area.name    AS s_area,
                        subarea.name AS s_subarea,
                        assunto.name AS s_assunto
                FROM {seox_area} AS area
                INNER JOIN {seox_subarea} AS subarea ON area.id = subarea.id_area
                INNER JOIN {seox_assunto} AS assunto ON subarea.id = assunto.id_subarea';

         $query = $DB->get_records_sql($sql);

         if($query){
             return true;
         }else{
             return false;
         }
    }

    function display() {
        global $OUTPUT;
        
        //finalize the form definition if not yet done
        if (!$this->_definition_finalized) {
            $this->_definition_finalized = true;
            $this->definition_after_data();
        }

        if($this->verifyAreas()){

            $this->_form->display();

        }else{
            global $PAGE;
            $warningtextform = html_writer::tag('p', get_string('warningtextform', 'prova'));
            $warningbody = html_writer::tag('span', $warningtextform, array('id' => 'warningselectprova'));
            echo $warningbody; 
            $returnurl_cad = $PAGE->url->out_as_local_url(false);
            $url_form = new moodle_url('/mod/prova/screens/cad_area/view.php');
            $output = "<div style=' margin-top: 20px; display: flex; align-items: center; justify-content: center'>";
            $output .= html_writer::link(new moodle_url($url_form, array('returnurl' => $returnurl_cad)), get_string('btnformadd','prova'));//$OUTPUT->render($button);
            $output .= '</div>';

            echo $output;   
        }
    }

}