<?php
/**
 * Update Overdue Attempts Task
 */
namespace mod_prova\task;

defined('MOODLE_INTERNAL') || die();

require_once($CFG->dirroot . '/mod/prova/locallib.php');

/**
 * Update Overdue Attempts Task
 *
 * @package    mod_prova
 *
 */
class update_expired_attempts extends \core\task\scheduled_task {

    public function get_name() {
        return get_string('updateexpiredattemptstask', 'mod_prova');
    }

    /**
     *
     * Close off any overdue attempts.
     */
    public function execute() {
        global $CFG;

        require_once($CFG->dirroot . '/mod/prova/cronlib.php');
        $timenow = time();
        $overduehander = new \mod_prova_overdue_attempt_updater();

        $processto = $timenow;

        mtrace('  Looking for prova expired prova attempts...');

        list($count, $provacount) = $overduehander->update_overdue_attempts($timenow, $processto);

        mtrace('  Considered ' . $count . ' attempts in ' . $provacount . ' provas.');
    }
}
