<?php
/**
 * Gera o form que será apresentado após o cadastro de uma questão.
 */
require_once('../config.php');
require_once($CFG->dirroot . '/mod/prova/managelib.php');

\mod_prova\manager::has_permission_to_access();

global $USER;

$provaid = optional_param('provaid', null,  PARAM_INT);
$originalreturnurl = optional_param('returnurl', 0, PARAM_LOCALURL);

$url = new moodle_url('/mod/prova/components/addprovas/addprova.php');
if ($provaid !== 0) {
	$url->param('provaid', $provaid);
}
if ($originalreturnurl !== 0) {
	$url->param('returnurl', $originalreturnurl);
}

if ($provaobj = $DB->get_record('seox_prova', array('id' => $provaid)) and $provaobj->vezes_usada > 0) {
	$url = new moodle_url('/mod/prova/components/addprovas/edit.php', array('provaid' => $provaid, 'sesskey' => sesskey()));
	if ($originalreturnurl and $originalreturnurl !== 0) {
		$url->param('returnurl', $originalreturnurl);
	}
	redirect($url);
}

$PAGE->set_url($url);
$PAGE->set_pagelayout('base');
$PAGE->set_context(context_course::instance(SEOX_COURSE_ID));

$thisblock_form = new provacomp_addprovas\form\addprovas_form();

if($thisblock_form->is_cancelled()) {
    die(redirect(new moodle_url('/mod/prova/components/provas.php')));
} elseif ($fromform = $thisblock_form->get_data()) {
    $isAllClean = true;
	if ($fromform->md_areas == 0) {
	    print_error('addquestions:invalidarea', 'provacomp_addquestions', $questionid);
	    $isAllClean = false;
	}
	if ($fromform->md_subareas == 0) {
	    print_error('addquestions:invalidsubarea', 'provacomp_addquestions', $questionid);
	    $isAllClean = false;
	}
	if ($fromform->md_assuntos == 0) {
	    print_error('addquestions:invalidassunto', 'provacomp_addquestions', $questionid);
	    $isAllClean = false;
    }
    if ($fromform->md_name == '') {
	    print_error('err_invalidname', 'provacomp_addprovas', $questionid);
	    $isAllClean = false;
	}

	$data = array(
		'name' => $fromform->md_name,
		'id_area' => $fromform->md_areas,
		'id_subarea' => $fromform->md_subareas,
		'id_assunto' => $fromform->md_assuntos,
		'createdby' => $USER->id,
		// TODO: add user, createdAt e updatedAt
	);
	// print_object($fromform);
	// exit;
	if ($isAllClean) {
		if (array_key_exists('update', $fromform) and $fromform->update) {
			if ($data['id_area'] != $fromform->id_area
				or $data['id_subarea'] != $fromform->id_subarea
				or $data['id_assunto'] != $fromform->id_assunto
				or $data['name'] != $fromform->name) {

				$data['id'] = $fromform->provaid;
				if (!$resultid = $DB->update_record_raw('seox_prova', $data)) {
			    	print_error('err_addprova_dberror_insert', 'provacomp_addprovas');
				}
				$resultid = $fromform->provaid;
			}
		} else {
			if (!$resultid = $DB->insert_record_raw('seox_prova', $data)) {
			    print_error('err_addprova_dberror_insert', 'provacomp_addprovas');
			}
			if (!$fromform->returnurl or $fromform->returnurl === 0) {
				$fromform->returnurl = new moodle_url('/mod/prova/components/provas.php', array('provaid' => $resultid));
			}
		}

		$url = new moodle_url('/mod/prova/components/addprovas/edit.php', array('provaid' => $resultid, 'sesskey' => sesskey()));
		if ($fromform->returnurl and $fromform->returnurl !== 0) {
			$url->param('returnurl', $fromform->returnurl);
		}
    	redirect($url);
		exit;
	}

} else {
	
	$dataprova = [];
	if(!empty($provaid)){
		$sql = 'SELECT name, id_area, id_subarea, id_assunto
			FROM {seox_prova} 
			Where id = '.$provaid;
		$formprova = $DB->get_record_sql($sql);
	
		$pagename = get_string('editingprovax', 'provacomp_addprovas', format_string($formprova->name));

		$dataprova['update'] = true;
		$dataprova['provaid'] = $provaid;
		$dataprova['md_name'] = $formprova->name;
		$dataprova['md_areas'] = $formprova->id_area;
		$dataprova['md_subareas'] = $formprova->id_subarea;
		$dataprova['md_assuntos'] = $formprova->id_assunto;
		$dataprova['id_name'] = $formprova->name;
		$dataprova['id_areas'] = $formprova->id_area;
		$dataprova['id_subareas'] = $formprova->id_subarea;
		$dataprova['id_assuntos'] = $formprova->id_assunto;
	} else {
		$pagename = get_string('form_title', 'provacomp_addprovas');
	}

	$PAGE->set_title($pagename);
	$PAGE->set_heading($pagename);

	// Exibição padrão
    echo $OUTPUT->header();

    echo html_writer::tag('h3', $pagename, null);
	echo '<br>';

	$dataprova['returnurl'] = $originalreturnurl;
	$thisblock_form->set_data($dataprova);
	$thisblock_form->display();
	$PAGE->requires->yui_module(
		'moodle-provacomp_buscaquestoes-filtro_searchquestions',
		'M.provacomp_buscaquestoes.filtro_searchquestions.init',
		$thisblock_form->get_filtros_areas_content()
	);

	echo $OUTPUT->footer();
}