<?php
/**
 * The add random questions form.
 */
namespace provacomp_addprovas\form;

include_once($CFG->libdir.'/formslib.php');

class addrandom_form extends \provacomp_addprovas\form\buscaquestoes_form {

    public function definition() {
        $mform =& $this->_form;

        // Form da busca de questoes
        $this->render_select_filtros_areas($mform);
        $this->render_select_dificuldades($mform);
        $this->render_select_qtypes($mform);
        $this->render_input_text($mform);

        $this->add_classes_to_elements($mform);

        $this->add_action_buttons($cancel=false, $submitlabel=get_string('buscaquestoes:buscarquestoes_button', 'provacomp_buscaquestoes'));

    }

    public function validation($fromform, $files) {
        $errors = parent::validation($fromform, $files);

        if (!empty($fromform['newcategory']) && trim($fromform['name']) == '') {
            $errors['name'] = get_string('categorynamecantbeblank', 'question');
        }

        return $errors;
    }

    protected function add_classes_to_elements($mform) {

        $generalname = array('data' => 'buscaquestoes');

        $mform->setAttributes($generalname);

        $targets = array('md_areas_random', 'md_subareas_random', 'md_assuntos_random', 'md_dificuldades_random', 'md_qtypes_random', 'md_text_random');

        foreach ($targets as $value) {
            $target = $mform->getElement($value);
            $target->setAttributes(array_merge($target->getAttributes(), $generalname));
        }
    }

    protected function render_select_filtros_areas($mform) {

        $areas = array(0 => '');
        $subareas = array(0 => '');
        $assuntos = array(0 => '');

        $this->get_filtros_areas_content_db($areas, $subareas, $assuntos);

        $mform->addElement('select', 'md_areas_random', get_string('buscaquestoes:area_titles', 'provacomp_buscaquestoes'), $areas);

        $mform->addElement('select', 'md_subareas_random', get_string('buscaquestoes:subarea_titles', 'provacomp_buscaquestoes'), $subareas);
        
        $mform->addElement('select', 'md_assuntos_random', get_string('buscaquestoes:assunto_titles', 'provacomp_buscaquestoes'), $assuntos);
    }

    protected function render_select_dificuldades($mform) {
        $mform->addElement(
            'autocomplete',
            'md_dificuldades_random', 
            get_string('buscaquestoes:dificuldades_titles', 'provacomp_buscaquestoes'), 
            self::$dificuldadeslist, 
            array('multiple' => true)
        );
        $mform->addHelpButton('md_dificuldades_random', 'buscaquestoes:autocomplete_help', 'provacomp_buscaquestoes');
    }

    protected function render_select_qtypes($mform) {
        $qtypes = $this->get_filtros_qtypes();
        if (!$qtypes) { return; }
        $qtypes = array_merge(array(''), $qtypes);

        $mform->addElement(
            'autocomplete',
            'md_qtypes_random', 
            get_string('buscaquestoes:qtypes_titles', 'provacomp_buscaquestoes'), 
            $qtypes, 
            array('multiple' => true)
        );
        $mform->addHelpButton('md_qtypes_random', 'buscaquestoes:autocomplete_help', 'provacomp_buscaquestoes');
    }

    protected function render_input_text($mform) {
        $attributes = array(
            'size' => '60'
        );
        $mform->addElement('text', 'md_text_random', get_string('buscaquestoes:palavrachave_title', 'provacomp_buscaquestoes'), $attributes);
        $mform->setType('md_text_random', PARAM_ALPHA);
    }

    public function populate_elements($defaults) {
        if (empty($defaults)) { return; }
        $mform =& $this->_form;
        if (array_key_exists('md_areas', $defaults)) {
            $mform->setDefault('md_areas_random', $defaults['md_areas']);
        }
        if (array_key_exists('md_subareas', $defaults)) {
            $mform->setDefault('md_subareas_random', $defaults['md_subareas']);
        }
        if (array_key_exists('md_assuntos', $defaults)) {
            $mform->setDefault('md_assuntos_random', $defaults['md_assuntos']);
        }
        if (array_key_exists('md_dificuldades', $defaults)) {
            $mform->getElement('md_dificuldades_random')->setSelected($defaults['md_dificuldades']);
        }
        if (array_key_exists('md_qtypes', $defaults)) {
            $mform->getElement('md_qtypes_random')->setSelected($defaults['md_qtypes']);
        }
        if (array_key_exists('md_text', $defaults)) {
            $mform->setDefault('md_text_random', $defaults['md_text']);
        }
    }
}
