<?php
/**
 * A column type for the name followed by the start of the question text.
 *
 * @package   provacomp_addprovas
 * @category  question
 */

namespace provacomp_addprovas\question\bank;
defined('MOODLE_INTERNAL') || die();


/**
 * A column type for the name followed by the start of the question text.
 */
class question_name_text_column extends \core_question\bank\question_name_column {
    public function get_name() {
        return 'questionnametext';
    }

    protected function display_content($question, $rowclasses) {
        echo '<div>';
        $labelfor = $this->label_for($question);
        if ($labelfor) {
            echo '<label for="' . $labelfor . '">';
        }
        echo prova_question_tostring($question);
        if ($labelfor) {
            echo '</label>';
        }
        echo '</div>';
    }

    public function get_required_fields() {
        $fields = parent::get_required_fields();
        $fields[] = 'q.questiontext';
        $fields[] = 'q.questiontextformat';
        return $fields;
    }
}
