<?php
defined('MOODLE_INTERNAL') || die();

/**
 * Function from /mod/quiz/lib.php
 * Based on mod_quiz_output_fragment_quiz_question_bank()
 *
 * Generates the question bank in a fragment output. This allows
 * the question bank to be displayed in a modal.
 */
function provacomp_addprovas_output_fragment_prova_question_bank($args) {

    \mod_prova\manager::has_permission_to_access();

    global $CFG, $DB, $PAGE;
    require_once($CFG->dirroot . '/mod/prova/locallib.php');
    require_once($CFG->dirroot . '/question/editlib.php');

    $querystring = preg_replace('/^\?/', '', $args['querystring']);
    $params = [];
    parse_str($querystring, $params);
    $params['courseid'] = SEOX_COURSE_ID;

    $thispageurl = new moodle_url('/mod/prova/components/addprovas/edit.php', $params);
    $course = $DB->get_record('course', array('id' => $params['courseid']), '*', MUST_EXIST);
    $prova = (array_key_exists('provaid', $params)) ? $params['provaid'] : null;
    $contexts = new \question_edit_contexts(context_course::instance($course->id));
    $is_random = (array_key_exists('random', $params) and $params['random']) ? true : false;

    $questionbank = new provacomp_addprovas\question\bank\custom_view($contexts, $thispageurl, $course, null, $prova, $is_random);

    $renderer = $PAGE->get_renderer('provacomp_addprovas', 'edit');

    return $renderer->question_bank_contents($questionbank, $params);
}

/**
 * Function from /mod/quiz/lib.php
 * Based on quiz_format_question_grade()
 *
 * Formata a nota total da prova
 */
function prova_format_question_grade($grade) {
    return format_float($grade, 2);
}
