<?php
/**
 * Exibe o preview de uma prova.
 *
 * @package   provacomp_addprovas
 */

require_once(__DIR__ . '/../config.php');
require_once($CFG->dirroot . '/mod/prova/locallib.php');
require_once($CFG->dirroot . '/mod/prova/components/addprovas/locallib.php');
require_once('provalib.php');

// Get submitted parameters.
$provaid = required_param('provaid', PARAM_INT);
$page = optional_param('page', 1, PARAM_INT);

$PAGE->set_context(context_system::instance());

$attemptobj = new prova_attempt_preview($provaid);
$page = $attemptobj->force_page_number_into_range($page);
$PAGE->set_url($attemptobj->preview_url($provaid, $page));
// $PAGE->set_pagelayout('popup');
// $PAGE->force_settings_menu();
$PAGE->blocks->add_region('side-pre');

// Check login.
\mod_prova\manager::has_permission_to_access();

// Check the access rules.
$output = $PAGE->get_renderer('provacomp_addprovas');

// Get the list of questions needed by this page.
$slots = $attemptobj->get_slots($page);

// Check.
if (empty($slots)) {
    print_error('err_preview_invalid_page', 'provacomp_addprovas');
}

// Initialise the JavaScript.
$headtags = $attemptobj->get_html_head_contributions($page);
$PAGE->requires->js_init_call('M.mod_prova.init_attempt_form', null, false, prova_get_js_module());

$pagename = get_string('preview_title', 'provacomp_addprovas', $attemptobj->get_prova()->name);
$PAGE->set_title($pagename);
$PAGE->set_heading($pagename);

if ($attemptobj->is_last_page($page)) {
    $nextpage = -1;
} else {
    $nextpage = $page + 1;
}

echo $output->preview_page($attemptobj, $page, null, $slots, $nextpage);