<?php
/**
 * Esta página irá processar requisições vindas do preview de uma prova
 */

require_once(__DIR__ . '/../config.php');
require_once($CFG->dirroot . '/mod/prova/components/addprovas/locallib.php');
require_once('provalib.php');

// Remember the current time as the time any responses were submitted
// (so as to make sure students don't get penalized for slow processing on this page).
$timenow = time();

// Get submitted parameters.
$provaid     = required_param('provaid',  PARAM_INT);
$thispage      = optional_param('thispage', 0, PARAM_INT);
$nextpage      = optional_param('nextpage', 0, PARAM_INT);
$previous      = optional_param('previous',      false, PARAM_BOOL);
$next          = optional_param('next',          false, PARAM_BOOL);
$finishattempt = optional_param('finishattempt', false, PARAM_BOOL);
$timeup        = optional_param('timeup',        0,      PARAM_BOOL); // True if form was submitted by timer.
$scrollpos     = optional_param('scrollpos',     '',     PARAM_RAW);

// Set $nexturl now.
if ($next) {
    $page = $nextpage;
} else if ($previous && $thispage > 0) {
    $page = $thispage - 1;
} else {
    $page = $thispage;
}
if ($page == -1) {
    echo "<script>window.close();</script>";
    exit;
} else {
    $nexturl = prova_attempt_preview::preview_url($provaid, $page);
    if ($scrollpos !== '') {
        $nexturl->param('scrollpos', $scrollpos);
    }
}

// Check capabilities.
\mod_prova\manager::has_permission_to_access();
// Check login.
require_sesskey();

redirect($nexturl);