<?php
/**
 * Classe que comporta funções clonadas/alteradas e funções de
 * escopo glonal essenciais à exeução da funcionalidade 
 * "Criar Questões"
 */
namespace provacomp_addquestions\action;
defined('MOODLE_INTERNAL') || die();

require_once($CFG->dirroot.'/config.php');
require_once($CFG->dirroot . '/question/editlib.php');

use context_course;
use moodle_url;

class addquestions_actions {
    /**
     * Função clonada e alterada de /question/editlib.php
     * Esta função carrega é a responsável pela criação do botão
     * "Criar Questão"
     *
     * @param $url, recebe a url do arq php que irá adicionar uma questão
     * @param demais parâmetros vêm da função original
     */
    static function create_new_question_button($url, $categoryid, $params, $caption, $tooltip = '', $disabled = false) {
        global $CFG, $PAGE, $OUTPUT;
        static $choiceformprinted = false;
        $url->param('category', $categoryid);
        echo $OUTPUT->single_button($url, $caption, 'get', array('disabled'=>$disabled, 'title'=>$tooltip));

        if (!$choiceformprinted) {
            echo '<div id="qtypechoicecontainer">';
            echo print_choose_qtype_to_add_form(array());
            echo "</div>\n";
            $choiceformprinted = true;
        }
    }

    /**
     * Gera parametros necessários para criar uma questão
     *
     * @return os parâmetros necessários
     */
    static function generate_addquestion_params($returnurl=false) {
        global $DB, $CFG;
        require_once($CFG->dirroot . '/mod/prova/managelib.php');
        if (!$category = $DB->get_record('question_categories', array('name' => 'top', 'contextid' => context_course::instance(SEOX_COURSE_ID)->id))) {
            print_error('error_getquestioncategory', 'provacomp_addquestions');
        }
        $params = array(
            'courseid'  => SEOX_COURSE_ID,
            'category'  => $category->id,
        );
        if ($returnurl) {
            $params['returnurl'] = $returnurl;
        }
        return $params;
    }
}