<?php
/**
 * Classe que irá conter todos as funções ques simulam ações do moodle.
 * Estas funções estão sendo reescritas devido a necessidade de regras
 * personalizadas.
 */

namespace provacomp_buscaprovas\action;

class buscaprovas_actions {
	/**
	 * Função que irá simular a função "question_has_capability_on"
	 */
	static function custom_question_has_capability_on($question, $cap=null) {
	    global $DB;
	    $custom_q = $DB->get_record_sql("SELECT vezes_usada FROM {seox_questions} WHERE id_question = :questionid", ['questionid' => $question->id]);
	    return ($custom_q->vezes_usada <= 0);
	}

	/**
	 * Função que irá simular a função "question_require_capability_on"
	 */
	static function custom_question_require_capability_on($question, $cap) {
	    if (!self::custom_question_has_capability_on($question, $cap)) {
	        print_error('nopermissions', '', '', $cap);
	    }
	    return true;
	}

	/**
	 * Função que deleta uma prova e suas referencias das tabelas provas e prova_slots
	 * e subtrai 1 do vezes_usada da tabela prova_slots se ele não for 0
	 */
	static function delete_prova_reference($provaid) {
		global $DB;
		self::prova_availability($provaid);

		$sql1 = 'SELECT questionid FROM {seox_prova_slots} WHERE provaid = '.$provaid;
		$resultsql1 = $DB->get_records_sql($sql1);
		foreach ($resultsql1 as $key ) {

		   $sql2 = 'UPDATE {seox_questions}
		   SET vezes_usada = vezes_usada-1
		   WHERE id_question = '.$key->questionid.' AND vezes_usada > 0';
		   $resultsql2 = $DB->execute($sql2);
		   
		}
		$DB->delete_records('seox_prova', array('id' => $provaid));
		$DB->delete_records('seox_prova_slots', array('provaid' => $provaid));
	}

	/**
	 * Função que verifica se prova nunca foi usada
	 */
	static function prova_availability($provaid) {
		global $DB;
		if (!$seoxq = $DB->get_record('seox_prova', array('id' => $provaid))) {
   			print_error('provadoesnotexist', 'provacomp_buscaprovas');
		}
		if (intval($seoxq->vezes_usada) > 0) {
    		print_error('error_question_alreadyinuse', 'provacomp_buscaprovas');
		}
	}

	/**
	 * Função que verifica permissões no moodle
	 */
	static function has_permission_to_access() {
		global $USER;
		$access_power = array('manager', 'editingteacher', 'coursecreator');
		if (!is_siteadmin() and (!$role = current(get_user_roles($thiscontext, $USER->id)) || !in_array($role->shortnam, $access_power))) {
		    print_error('error_teacherwithnopower', 'provacomp_buscaprovas');
		}
	}
}