<?php

namespace provacomp_buscaprovas\form;

require_once $CFG->libdir . '/formslib.php';

class buscaprovas_form extends \mod_prova\form\seox_check_areas_form {

	public function definition() {

		$mform = &$this->_form;

		//$mform->addElement('header', 'displayinfo', get_string('form_header_title', 'provacomp_buscaprovas'));

		$this->render_select_filtros_areas($mform);
		$this->render_select_dificuldades($mform);
		$this->render_input_text($mform);

		$mform->addElement('hidden', 'questionid');
		$mform->setType('questionid', PARAM_INT);
		$this->add_action_buttons($cancel = false, $submitlabel = get_string('buscarprovas_button', 'provacomp_buscaprovas'));
	}

    public function add_classes_to_elements() {

        $mform = &$this->_form;

        $generalname = array('data' => 'buscaprovas');

        $mform->setAttributes($generalname);

        $targets = array('md_areas', 'md_subareas', 'md_assuntos', 'md_dificuldades', 'md_text');

        foreach ($targets as $value) {
            $target = $mform->getElement($value);
            $target->setAttributes(array_merge($target->getAttributes(), $generalname));
        }
    }

	protected function render_select_filtros_areas($mform) {

		$areas = array(0 => '');
		$subareas = array(0 => '');
		$assuntos = array(0 => '');

		$this->get_filtros_areas_content_db($areas, $subareas, $assuntos);

		$mform->addElement('select', 'md_areas', get_string('area_titles', 'provacomp_buscaprovas'), $areas);

		$mform->addElement('select', 'md_subareas', get_string('subarea_titles', 'provacomp_buscaprovas'), $subareas);

		$mform->addElement('select', 'md_assuntos', get_string('assunto_titles', 'provacomp_buscaprovas'), $assuntos);
	}

	protected function render_select_dificuldades($mform) {
		$mform->addElement(
			'autocomplete',
			'md_dificuldades',
			get_string('dificuldades_titles', 'provacomp_buscaprovas'),
			self::$dificuldadeslist,
			array('multiple' => true)
		);
		$mform->addHelpButton('md_dificuldades', 'autocomplete_help', 'provacomp_buscaprovas');
	}

	protected function render_input_text($mform) {
		$attributes = array(
			'size' => '50',
		);
		$mform->addElement('text', 'md_text', get_string('palavrachave_title', 'provacomp_buscaprovas'), $attributes);
		$mform->setType('md_text', PARAM_TEXT);
	}

	public function populate_elements($defaults) {
		if (empty($defaults)) {return;}
		$mform = &$this->_form;
		if (array_key_exists('md_areas', $defaults)) {
			$mform->setDefault('md_areas', $defaults['md_areas']);
		}
		if (array_key_exists('md_subareas', $defaults)) {
			$mform->setDefault('md_subareas', $defaults['md_subareas']);
		}
		if (array_key_exists('md_assuntos', $defaults)) {
			$mform->setDefault('md_assuntos', $defaults['md_assuntos']);
		}
		if (array_key_exists('md_dificuldades', $defaults)) {
			$mform->getElement('md_dificuldades')->setSelected($defaults['md_dificuldades']);
		}
		if (array_key_exists('md_text', $defaults)) {
			$mform->setDefault('md_text', $defaults['md_text']);
		}
	}
}