<?php
/**
 * Este arquivo usa como base funções dentro do moodle
 * que envolvam a deleção de uma prova. 
 */ 
require_once('../config.php');

global $USER;

use \provacomp_buscaprovas\action\buscaprovas_actions as Custom_actions;

\mod_prova\manager::has_permission_to_access();

$PAGE->set_url(new moodle_url('/mod/prova/components/buscaprovas/deleteprova.php'));
$pagename = get_string('deleteprova_title', 'provacomp_buscaprovas');
$PAGE->set_context(context_system::instance());
$PAGE->set_title($pagename);
$PAGE->set_heading($pagename);
$PAGE->set_pagelayout('admin');
$PAGE->navbar->add($pagename);

if (($confirm = optional_param('confirm', '', PARAM_ALPHANUM)) and confirm_sesskey()) {
    $deleteselected = required_param('deleteselected', PARAM_INT);
    if ($confirm == md5($deleteselected)) {
        Custom_actions::delete_prova_reference($deleteselected);
        /* question_delete_question($deleteselected); */
        redirect(required_param('returnurl', PARAM_LOCALURL));
    } else {
        print_error('invalidconfirm', 'question');
    }
}

$provaid = required_param('deleteselected', PARAM_INT);

if (!$prova = $DB->get_record('seox_prova', array('id' => $provaid))) {
    print_error('provadoesnotexist', 'provacomp_buscaprovas', $returnurl);
}

$returnurl = new moodle_url(required_param('returnurl', PARAM_LOCALURL));

$params = array(
    'id' => $provaid,
    'returnurl' => $returnurl,
);
$cancellUrl = new moodle_url($returnurl, $params);
$baseurl = new moodle_url('deleteprova.php', $params);
$deleteurl = new moodle_url($baseurl, array(
    'deleteselected' => $provaid,
    'confirm' => md5($provaid),
    'sesskey' => sesskey())
);

$continue = new single_button($deleteurl, get_string('delete'), 'post');
echo $OUTPUT->header();
if($USER->id != $prova->createdby){
    echo $OUTPUT->notification(get_string('err_provadelete', 'provacomp_buscaprovas'), 'notifyerros');
}else{
    echo $OUTPUT->confirm(get_string('deleteprovacheck', 'provacomp_buscaprovas', $prova->name), $continue, $cancellUrl);
}

echo $OUTPUT->footer();