<?php 
/**
 * Library of functions used by the provacomp_buscaprovas.
 */
defined('MOODLE_INTERNAL') || die();

require_once('../config.php');

\mod_prova\manager::has_permission_to_access();

/**
 * Função que duplica uma prova (todas infos da tabela seox_prova) 
 * e suas questões (todas as infos da 
 * tabela seox_questions)
 */
function duplicate_prova($provaid){

    global $DB; 

    //Obtem todos os dados da tabela seox_prova com base no id passado com parâmetro
    $tb_seox_prova = $DB->get_records('seox_prova', array('id' => $provaid));
    foreach ($tb_seox_prova as $key => $value) {
        global $USER;
        $userid = $USER->id;

        $tb_seox_prova_obj = new stdClass();
        $tb_seox_prova_obj->name = $value->name . get_string('duplicate_label', 'provacomp_buscaprovas');
        $tb_seox_prova_obj->grade = $value->grade;
        $tb_seox_prova_obj->sumgrades = $value->sumgrades;
        $tb_seox_prova_obj->id_area = $value->id_area;
        $tb_seox_prova_obj->id_subarea = $value->id_subarea;
        $tb_seox_prova_obj->id_assunto = $value->id_assunto;
        $tb_seox_prova_obj->dificuldade = $value->dificuldade;
        $tb_seox_prova_obj->vezes_usada = 0;
        $tb_seox_prova_obj->usermodified = $value->usermodified;
        $tb_seox_prova_obj->timecreated = $value->timecreated;
        $tb_seox_prova_obj->timemodified = $value->timemodified;
        $tb_seox_prova_obj->createdby = $userid;

        $insert_seox_prova = $DB->insert_record('seox_prova', $tb_seox_prova_obj);
    }

     //Obtem todos os dados da tabela seox_prova_slots com base no id da prova passado com parâmetro
    $tb_seox_prova_slots = $DB->get_records('seox_prova_slots', array('provaid' => $provaid));
    foreach ($tb_seox_prova_slots as $key => $value) {
        $tb_s_p_slots_obj = new stdClass();
        $tb_s_p_slots_obj->slot = $value->slot;
        $tb_s_p_slots_obj->provaid = $insert_seox_prova ;
        $tb_s_p_slots_obj->page = $value->page;
        $tb_s_p_slots_obj->questionid = $value->questionid;
        $tb_s_p_slots_obj->maxmark = $value->maxmark;

        $insert_seox_prova_slots = $DB->insert_record('seox_prova_slots', $tb_s_p_slots_obj);
        
        //Atualização do campo vezes_usada da tabela seox_question 
	    $DB->execute('UPDATE {seox_questions} SET vezes_usada = vezes_usada + 1 WHERE id_question = ?', [$tb_s_p_slots_obj->questionid]);
    }
    return $insert_seox_prova;
}