<?php

$DB || $PAGE || $OUTPUT || exit;


require_once($CFG->dirroot . '/mod/prova/managelib.php');

// TODO: configurar Capabilities
// require_login($course);
use provacomp_buscaprovas\form\buscaprovas_form;

$thisblock_form = new buscaprovas_form(); 


if($thisblock_form->is_cancelled()) {
	// TODO: deleta questao e redireciona para lugar correto
    // $courseurl = new moodle_url('/course/view.php', array('id' => $id));
    // redirect($courseurl);
} else {
	// -------- LAST SEARCH AREA / Grab by url
	$get_last_search = array();
	if ($md_areas = optional_param('areas', 0, PARAM_INT)) {
		$get_last_search['md_areas'] = $md_areas;
	}
	if ($md_subareas = optional_param('subareas', 0, PARAM_INT)) {
		$get_last_search['md_subareas'] = $md_subareas;
	}
	if ($md_assuntos = optional_param('assuntos', 0, PARAM_INT)) {
		$get_last_search['md_assuntos'] = $md_assuntos;
	}
	if ($md_dificuldades = optional_param('dificuldades', 0, PARAM_ALPHANUMEXT) or $md_dificuldades === '0') {
		$array = explode('-', $md_dificuldades);
		$get_last_search['md_dificuldades'] = (is_array($array) ? $array : array($array));
	}
	if ($md_text = optional_param('text', null, PARAM_ALPHANUMEXT)) {
		$get_last_search['md_text'] = $md_text;
	}

	// -------- FILTROS AREA
	if (!$thisblock_form->get_data() and !empty($get_last_search)) {
		$thisblock_form->populate_elements($get_last_search);
	}
	$thisblock_form->display();
	$PAGE->requires->yui_module(
		'moodle-provacomp_buscaprovas-filtro_searchquestions',
		'M.provacomp_buscaprovas.filtro_searchquestions.init',
		$thisblock_form->get_filtros_areas_content()
	);

	// -------- RESULT AREA
	if ($provaid = optional_param('provaid', 0, PARAM_INT)) {

		$data = array('prova.id = '.$provaid);
		$urldata = array('provaid' => $provaid);
		print_table_seox($data, $urldata);

	} elseif ($fromform = $thisblock_form->get_data() or
		(!empty($get_last_search) and $fromform = (Object) $get_last_search)) {

		$data = array();
		$urldata = array();

		if (array_key_exists('md_areas', $fromform) and $fromform->md_areas != 0) {
			$data[] = 'prova.id_area = '.$fromform->md_areas;
			$urldata['areas'] = $fromform->md_areas;
		}
		if (array_key_exists('md_subareas', $fromform) and $fromform->md_subareas != 0) {
			$data[] = 'prova.id_subarea = '.$fromform->md_subareas;
			$urldata['subareas'] = $fromform->md_subareas;
		}
		if (array_key_exists('md_assuntos', $fromform) and $fromform->md_assuntos != 0) {
			$data[] = 'prova.id_assunto = '.$fromform->md_assuntos;
			$urldata['assuntos'] = $fromform->md_assuntos;
		}
		if (!empty($fromform->md_dificuldades)) {
			$str = 'prova.dificuldade IN (';
			$str .= implode(',', $fromform->md_dificuldades);
			$str .= ')';
			$data[] = $str;
			$urldata['dificuldades'] = implode('-', $fromform->md_dificuldades);
		}
		if (array_key_exists('md_text', $fromform) and $fromform->md_text != '') {
			$data[] = "LOWER(prova.name) LIKE '%".strtolower($fromform->md_text)."%'";
			$urldata['text'] = $fromform->md_text;
		}
		
		print_table_seox($data, $urldata);
		
	}

}

function print_table_seox($data, $urldata) {
	global $DB, $OUTPUT;
	/* QUERY QUE NÂO TRAZ VAZIAS 
	SELECT prova.id, name, id_area, id_subarea, id_assunto, COUNT(slots.provaid) FROM mdl_seox_prova prova INNER JOIN mdl_seox_prova_slots slots ON prova.id = slots.provaid GROUP BY slots.provaid
	*/
	$sql = 'SELECT 
			prova.id AS provaid,
			prova.name AS nome, 
			area.name AS area,  
			subarea.name AS subarea, 
			assunto.name AS assunto, 
			prova.dificuldade AS dificuldade, 
			prova.vezes_usada AS vezes_usada,
			COUNT(slots.id) AS nro_questions 
		FROM {seox_prova} prova
		LEFT JOIN {seox_prova_slots} slots
		ON prova.id = slots.provaid
		LEFT JOIN {seox_area} area
		ON prova.id_area = area.id
		LEFT JOIN {seox_subarea} subarea
		ON prova.id_subarea = subarea.id
		LEFT JOIN mdl_seox_assunto assunto
		ON prova.id_assunto = assunto.id';


	if (!empty($data)) {
		$sql .= ' WHERE '.implode(' AND ', $data);
	} 

	$sql .= ' GROUP BY prova.id, area.id, subarea.id, assunto.id
		ORDER BY prova.id DESC;';
	$results = $DB->get_records_sql($sql);

	
	if (!empty($results)) {
		$table = new html_table();
		$table->head = array('Nome', 'Área', 'Subárea', 'Assunto', 'Dificuldade', 'Vezes Utilizada', 'Qtd de Questões', 'Ações');

		// Gera o body da tabela
		$cont = 1;
		foreach ($results as $prova) {
			$qid = null;
			$courseid = SEOX_COURSE_ID;
			$vezes_usada = $prova->vezes_usada;
			$row = new html_table_row();
			foreach ($prova as $key => $field) {
				
				if ($key == 'provaid') { 
					$qid = $field;
					continue; 
				}
				if ($key == 'dificuldade') {
					$row->cells[] = \provacomp_buscaprovas\form\buscaprovas_form::$dificuldadeslist[$field];
					continue;
				}
				if ($key == 'qtext') {
					$field = strip_tags($field);
					$begin = strpos($field, $urldata['md_text']);
					$pre = ($begin > 0) ? '...' : '';
					$pos = ($begin + 60 < strlen($field)-1) ? '...' : '';
					$row->cells[] = $pre . substr($field, $begin, 60) . $pos;
					continue;
				}
				if ($key == 'vezes_usada') {
					$vezes_usada = intval($field);
				}
				if ($key == 'nro_questions' and intval($field) <= 0) {
					if ($cont % 2 == 1) {
						$row->style = 'background-color: #f5c6cb;';
					} else {
						$row->style = 'background-color: #f8d7da;';
					}
					$row->attributes['title'] = get_string('empty_prova', 'provacomp_buscaprovas');
				}
				$row->cells[] = $field;
			}

			// Actions Field
			// -- Preview
			$last_column = '<div style="display:inline-block; width: 100px">';
			$previewurl = new moodle_url('/mod/prova/components/addprovas/preview.php', array(
				'provaid' => $prova->provaid,
			));
			$previewimage = $OUTPUT->pix_icon('t/preview', get_string('preview'), '', array('class' => 'iconsmall'));
    		$previewaction = new popup_action('click', $previewurl, 'questionpreview', array(
		        'height' => 600,
		        'width' => 800,
		    ));
			$last_column .= $OUTPUT->action_link($previewurl, $previewimage, $previewaction, array());

			if ($vezes_usada <= 0) {
				$returnurl = new moodle_url('/mod/prova/components/provas.php', $urldata);
				$returnurl = $returnurl->out_as_local_url(false);

				global $USER;

				//Obtem o ID do usuário que criou a prova da tabela seox_prova
				$user_create = $DB->get_record('seox_prova', ['id' => $prova->provaid], 'createdby');

				/*Verifica se o logado é o mesmo que criou a prova. Se for, 
				* exibe os botões de Editar e Deletar a prova. */
				if($USER->id == $user_create->createdby){
					// -- Edit
					$editurl = new moodle_url('/mod/prova/components/addprovas/editprova.php', array(
						'provaid' => $prova->provaid,
						'returnurl' => $returnurl,
					));
					$editaction = $OUTPUT->action_icon($editurl, new pix_icon('t/edit', get_string('edit')), null, array('class' => 'seox_leanblocks-action'));
					$last_column .= $editaction;

					// -- Delete
					$deleteurl = new moodle_url('/mod/prova/components/buscaprovas/deleteprova.php', array(
						'deleteselected' => $prova->provaid,
						'sesskey' => sesskey(),
						'returnurl' => $returnurl,
					));
					$deleteaction = $OUTPUT->action_icon($deleteurl, new pix_icon('t/delete', get_string('delete')), null, array('class' => 'seox_leanblocks-action'));
					$last_column .= $deleteaction;
				}
			}
			// -- Duplicate
			$duplicateurl = new moodle_url('/mod/prova/components/buscaprovas/processduplicateprova.php', array(
				'provaid' => $prova->provaid,
				'sesskey' => sesskey(),
				/* 'returnurl' => $returnurl, */
			));
			$duplicateaction = $OUTPUT->action_icon($duplicateurl, new pix_icon('t/copy', get_string('duplicate', 'provacomp_buscaprovas')), null, array('class' => 'seox_leanblocks-action'));
			$last_column .= $duplicateaction;
			$row->cells[] = $last_column . '</div>';

			$table->data[] = $row;
			$cont++;
		}
		echo html_writer::table($table);
	} else {
		echo html_writer::tag('p', get_string('noresults_at_search', 'provacomp_buscaprovas'));
	}
}