var SELECTOR = {
	AREA: '#id_md_areas',
	SUBAREA: '#id_md_subareas',
	ASSUNTO: '#id_md_assuntos',
	DOM_AREA: 'id_md_areas',
	DOM_SUBAREA: 'id_md_subareas',
	DOM_ASSUNTO: 'id_md_assuntos',
	BODY: 'body',
	AUTOCOMPLETE_BOX: '.form-autocomplete-suggestions li',
};

M.provacomp_buscaprovas = M.provacomp_buscaprovas || {};
var NS = M.provacomp_buscaprovas.filtro_searchquestions = {};


NS.init = function(params) {
	this.params = params;
    Y.delegate('change', this.populateSubarea, Y.config.doc, SELECTOR.AREA);
    Y.delegate('change', this.populateAssunto, Y.config.doc, SELECTOR.SUBAREA);
    this.removeMissSelections();
};

NS.removeMissSelections = function() {
	var id_area = document.getElementById(SELECTOR.DOM_AREA).value;
	var subarea = document.getElementById(SELECTOR.DOM_SUBAREA);
	var assunto = document.getElementById(SELECTOR.DOM_ASSUNTO);
	var subareaTarget = subarea.value;
	var assuntoTarget = assunto.value;

	subarea.innerHTML = '<option value="0"></option>';
	assunto.innerHTML = '<option value="0"></option>';

	if (id_area != 0) {
		var subareas = NS.params[id_area]['subareas'];
		Object.keys(subareas).map(function(index) {
			var o = new Option(subareas[index]['name'], index);
			subarea.appendChild(o);
			subarea.value = subareaTarget;
		});
	}
		
	if (subareaTarget != 0) {
		var assuntos = NS.params[id_area]['subareas'][subareaTarget]['assuntos'];
		Object.keys(assuntos).map(function(index) {
			var o = new Option(assuntos[index]['name'], index);
			assunto.appendChild(o);
			assunto.value = subareaTarget;
		});
	}
}

NS.includeOptionsFiltroArea = function(target, target_jq) {
	Object.keys(target).map(function(index) {
		var o = new Option(target[index]['name'], index);
		target_jq.append(o);
	});
}

NS.populateSubarea = function(e) {
	var id_area = $(e.currentTarget._node).val();
	var subarea_jq = $(SELECTOR.SUBAREA);
	var assunto_jq = $(SELECTOR.ASSUNTO);
	subarea_jq.find('option').not('[value="0"]').remove();
	assunto_jq.find('option').not('[value="0"]').remove();

	if (id_area == 0) { return; }

	var subareas = NS.params[id_area]['subareas'];
	NS.includeOptionsFiltroArea(subareas, subarea_jq);
};

NS.populateAssunto = function(e) {
	var id_area = $(SELECTOR.AREA).val();
	var id_subarea = $(e.currentTarget._node).val();
	var assunto_jq = $(SELECTOR.ASSUNTO);
	assunto_jq.find('option').not('[value="0"]').remove();

	if (id_area == 0) { return; }
	if (id_subarea == 0) { return; }

	var assuntos = NS.params[id_area]['subareas'][id_subarea]['assuntos'];
	NS.includeOptionsFiltroArea(assuntos, assunto_jq);
};