<?php
/**
 * Classe que irá conter todos as funções ques simulam ações do moodle.
 * Estas funções estão sendo reescritas devido a necessidade de regras
 * personalizadas.
 */

namespace provacomp_buscaquestoes\action;

class buscaquestoes_actions {
	/**
	 * Função que irá simular a função "question_has_capability_on"
	 */
	static function custom_question_has_capability_on($question, $cap=null) {
	    global $DB;
	    if (!array_key_exists('id', $question)) {
	    	return true;
	    }
	    if ($custom_q = $DB->get_record_sql("SELECT vezes_usada FROM {seox_questions} WHERE id_question = :questionid", ['questionid' => $question->id])) {
	    	return ($custom_q->vezes_usada <= 0);
	    }
	    return true;
	}

	/**
	 * Função que irá simular a função "question_require_capability_on"
	 */
	static function custom_question_require_capability_on($question, $cap) {
	    if (!self::custom_question_has_capability_on($question, $cap)) {
	        print_error('nopermissions', '', '', $cap);
	    }
	    return true;
	}

	/**
	 * Função que deleta um questão da tabela de questões seox
	 */
	static function delete_question_reference($questionid) {
		global $DB;
		self::question_availability($questionid);
		$DB->delete_records('seox_questions', array('id_question' => $questionid));
	}

	/**
	 * Função que verifica se questão foi utilizada mais de uma vez
	 */
	static function question_availability($questionid) {
		global $DB;
		if (!$seoxq = $DB->get_record('seox_questions', array('id_question' => $questionid))) {
   			print_error('questiondoesnotexist', 'question');
		}
		if (intval($seoxq->vezes_usada) > 0) {
    		print_error('error_question_alreadyinuse', 'provacomp_buscaquestoes');
		}
	}

	/**
	 * Função que verifica permissões no moodle
	 */
	static function has_permission_to_access() {
		\mod_prova\manager::has_permission_to_access();
	}
}