<?php

namespace provacomp_buscaquestoes\form;

include_once($CFG->libdir.'/formslib.php');

class buscaquestoes_form extends \mod_prova\form\seox_check_areas_form {

    public function definition() {

        $mform =& $this->_form;

        // $mform->addElement('header', 'displayinfo', get_string('buscaquestoes:form_header_title', 'provacomp_buscaquestoes'));
        
        $this->render_select_filtros_areas($mform);
        $this->render_select_dificuldades($mform);
        $this->render_select_qtypes($mform);
        $this->render_input_text($mform);

        $mform->addElement('hidden', 'questionid');
        $mform->setType('questionid', PARAM_INT);
        $this->add_action_buttons($cancel=false, $submitlabel=get_string('buscaquestoes:buscarquestoes_button', 'provacomp_buscaquestoes'));
    }

    protected function render_select_filtros_areas($mform) {

        $areas = array(0 => '');
        $subareas = array(0 => '');
        $assuntos = array(0 => '');

        $this->get_filtros_areas_content_db($areas, $subareas, $assuntos);

        $mform->addElement('select', 'md_areas', get_string('buscaquestoes:area_titles', 'provacomp_buscaquestoes'), $areas);

        $mform->addElement('select', 'md_subareas', get_string('buscaquestoes:subarea_titles', 'provacomp_buscaquestoes'), $subareas);
        
        $mform->addElement('select', 'md_assuntos', get_string('buscaquestoes:assunto_titles', 'provacomp_buscaquestoes'), $assuntos);
    }

    protected function render_select_dificuldades($mform) {
        $mform->addElement(
            'autocomplete',
            'md_dificuldades', 
            get_string('buscaquestoes:dificuldades_titles', 'provacomp_buscaquestoes'), 
            self::$dificuldadeslist, 
            array('multiple' => true)
        );
        $mform->addHelpButton('md_dificuldades', 'buscaquestoes:autocomplete_help', 'provacomp_buscaquestoes');
    }

    protected function render_select_qtypes($mform) {
        $qtypes = $this->get_filtros_qtypes();
        if (!$qtypes) { return; }
        $qtypes = array_merge(array(''), $qtypes);

        $mform->addElement(
            'autocomplete',
            'md_qtypes', 
            get_string('buscaquestoes:qtypes_titles', 'provacomp_buscaquestoes'), 
            $qtypes, 
            array('multiple' => true)
        );
        $mform->addHelpButton('md_qtypes', 'buscaquestoes:autocomplete_help', 'provacomp_buscaquestoes');
    }

    protected function render_input_text($mform) {
        $attributes = array(
            'size' => '60'
        );
        $mform->addElement('text', 'md_text', get_string('buscaquestoes:palavrachave_title', 'provacomp_buscaquestoes'), $attributes);
        $mform->setType('md_text', PARAM_TEXT);
    }


    protected function get_filtros_qtypes() {
        if (!defined('SEOX_COURSE_ID')) {
            return null;
        }
        $course = get_course(SEOX_COURSE_ID);
        if (!$qtypes_root = \core_question\output\qbank_chooser::get($course, [], null)) {
            return null;
        }
        $qtypes = $qtypes_root->sections[0]->items;
        $data = array();
        foreach ($qtypes as $key => $value) {
            $data[str_replace('qtype_', '', $value->id)] = $value->label;
        }
        return $data;
    }

    public function populate_elements($defaults) {
        if (empty($defaults)) { return; }
        $mform =& $this->_form;
        if (array_key_exists('md_areas', $defaults)) {
            $mform->setDefault('md_areas', $defaults['md_areas']);
        }
        if (array_key_exists('md_subareas', $defaults)) {
            $mform->setDefault('md_subareas', $defaults['md_subareas']);
        }
        if (array_key_exists('md_assuntos', $defaults)) {
            $mform->setDefault('md_assuntos', $defaults['md_assuntos']);
        }
        if (array_key_exists('md_dificuldades', $defaults)) {
            $mform->getElement('md_dificuldades')->setSelected($defaults['md_dificuldades']);
        }
        if (array_key_exists('md_qtypes', $defaults)) {
            $mform->getElement('md_qtypes')->setSelected($defaults['md_qtypes']);
        }
        if (array_key_exists('md_text', $defaults)) {
            $mform->setDefault('md_text', $defaults['md_text']);
        }
    }
}