<?php
/**
 * Este arquivo usa como base funções dentro do moodle
 * que envolvam a deleção de uma questão. 
 */ 
require_once('../config.php');
require_once($CFG->dirroot . '/lib/questionlib.php');

use \provacomp_buscaquestoes\action\buscaquestoes_actions as Custom_actions;

\mod_prova\manager::has_permission_to_access();

$PAGE->set_context(context_system::instance());
$PAGE->set_url(new moodle_url('/mod/prova/components/buscaquestoes/deletequestion.php'));
$pagename = get_string('deletequestion_title', 'provacomp_buscaquestoes');
$PAGE->set_title($pagename);
$PAGE->set_heading($pagename);
$PAGE->set_pagelayout('admin');
$PAGE->navbar->add($pagename);

if (($confirm = optional_param('confirm', '', PARAM_ALPHANUM)) and confirm_sesskey()) {
    $deleteselected = required_param('deleteselected', PARAM_INT);
    if ($confirm == md5($deleteselected)) {
        Custom_actions::delete_question_reference($deleteselected);
        question_delete_question($deleteselected);
        redirect(required_param('returnurl', PARAM_LOCALURL));
    } else {
        print_error('invalidconfirm', 'question');
    }
}

$questionid = required_param('deleteselected', PARAM_INT);
$courseid = required_param('courseid', PARAM_INT);
$returnurl = new moodle_url(required_param('returnurl', PARAM_LOCALURL));

Custom_actions::question_availability($questionid);

if (!$question = $DB->get_record('question', array('id' => $questionid))) {
    print_error('questiondoesnotexist', 'question', $returnurl);
}

$params = array(
    'courseid' => $courseid,
    'returnurl' => $returnurl,
);
$cancellUrl = new moodle_url($returnurl, $params);
$baseurl = new moodle_url('deletequestion.php', $params);
$deleteurl = new moodle_url($baseurl, array(
    'deleteselected' => $questionid,
    'confirm' => md5($questionid),
    'sesskey' => sesskey())
);

$continue = new single_button($deleteurl, get_string('delete'), 'post');
echo $OUTPUT->header();
echo $OUTPUT->confirm(get_string('deletequestionscheck', 'question', $question->name), $continue, $cancellUrl);
echo $OUTPUT->footer();