<?php

require_once(__DIR__.'/../config.php');
require_once($CFG->dirroot . '/mod/prova/managelib.php');

global $DB, $OUTPUT, $PAGE;

\mod_prova\manager::has_permission_to_access();

$thisblock_form = new provacomp_buscaquestoes\form\buscaquestoes_form();


// -------- LAST SEARCH AREA / Grab by url
$get_last_search = array();
if ($md_areas = optional_param('areas', 0, PARAM_INT)) {
	$get_last_search['md_areas'] = $md_areas;
}
if ($md_subareas = optional_param('subareas', 0, PARAM_INT)) {
	$get_last_search['md_subareas'] = $md_subareas;
}
if ($md_assuntos = optional_param('assuntos', 0, PARAM_INT)) {
	$get_last_search['md_assuntos'] = $md_assuntos;
}
if ($md_dificuldades = optional_param('dificuldades', 0, PARAM_ALPHANUMEXT) or $md_dificuldades === '0') {
	$array = explode('-', $md_dificuldades);
	$get_last_search['md_dificuldades'] = (is_array($array) ? $array : array($array));
}
if ($md_qtypes = optional_param('qtypes', null, PARAM_ALPHANUMEXT)) {
	$array = explode('-', $md_qtypes);
	$get_last_search['md_qtypes'] = (is_array($array) ? $array : array($array));
}
if ($md_text = optional_param('text', null, PARAM_ALPHANUMEXT)) {
	$get_last_search['md_text'] = $md_text;
}

// -------- FILTROS AREA
if (!$thisblock_form->get_data() and !empty($get_last_search)) {
	$thisblock_form->populate_elements($get_last_search);
}
$thisblock_form->display();
$PAGE->requires->yui_module(
	'moodle-provacomp_buscaquestoes-filtro_searchquestions',
	'M.provacomp_buscaquestoes.filtro_searchquestions.init',
	$thisblock_form->get_filtros_areas_content()
);

// -------- RESULT AREA
if ($questionid = optional_param('qid', 0, PARAM_INT)) {

	$data = array('seox.id = '.$questionid);
	$urldata = array('qid' => $questionid);
	print_table_seox($data, $urldata);

} elseif ($fromform = $thisblock_form->get_data() or
	(!empty($get_last_search) and $fromform = (Object) $get_last_search)) {

	$data = array();
	$urldata = array();

	if (array_key_exists('md_areas', $fromform) and $fromform->md_areas != 0) {
		$data[] = 'seox.id_area = '.$fromform->md_areas;
		$urldata['areas'] = $fromform->md_areas;
	}
	if (array_key_exists('md_subareas', $fromform) and $fromform->md_subareas != 0) {
		$data[] = 'seox.id_subarea = '.$fromform->md_subareas;
		$urldata['subareas'] = $fromform->md_subareas;
	}
	if (array_key_exists('md_assuntos', $fromform) and $fromform->md_assuntos != 0) {
		$data[] = 'seox.id_assunto = '.$fromform->md_assuntos;
		$urldata['assuntos'] = $fromform->md_assuntos;
	}
	if (!empty($fromform->md_dificuldades)) {
		$str = 'seox.dificuldade IN (';
		$str .= implode(',', $fromform->md_dificuldades);
		$str .= ')';
		$data[] = $str;
		$urldata['dificuldades'] = implode('-', $fromform->md_dificuldades);
	}
	if (!empty($fromform->md_qtypes)) {
		$str = "q.qtype IN ('";
		$str .= implode("','", $fromform->md_qtypes);
		$str .= "')";
		$data[] =  $str;
		$urldata['qtypes'] = implode('-', $fromform->md_qtypes);
	}
	if (array_key_exists('md_text', $fromform) and $fromform->md_text != '') {
		$data[] = "LOWER(q.questiontext) LIKE '%".strtolower($fromform->md_text)."%'
		OR LOWER(q.name) LIKE '%".strtolower($fromform->md_text)."%'";
		$urldata['text'] = $fromform->md_text;
	}
	print_table_seox($data, $urldata);
}

function print_table_seox($data, $urldata) {
	global $DB, $PAGE, $OUTPUT;
	// q.qtype AS qtype
	$sql = 'SELECT 
			seox.id_question AS seoxid,
			q.name AS qname,
			area.name AS s_area,
			subarea.name AS s_subarea,
			assunto.name AS s_assunto,
			q.questiontext AS qtext,
			q.qtype AS qtype,
			seox.dificuldade AS dificuldade,
			seox.vezes_usada AS vezes_usada
		FROM {question} AS q 
		INNER JOIN {seox_questions} AS seox ON seox.id_question=q.id
		INNER JOIN {seox_area} AS area ON seox.id_area=area.id
		INNER JOIN {seox_subarea} AS subarea ON seox.id_subarea=subarea.id
		INNER JOIN {seox_assunto} AS assunto ON seox.id_assunto=assunto.id';
	if (!empty($data)) {
		$sql .= ' WHERE '.implode(' AND ', $data);
	} 
	$sql .= ' ORDER BY seox.id DESC';
	$results = $DB->get_records_sql($sql);

	if (!empty($results)) {
		$table = new html_table();
		$table->head = array('Nome', 'Área', 'Subárea', 'Assunto', 'Palavras-chaves', 'Dificuldade', 'Vezes Utilizada', 'Ações', 'Estatísticas');

		// Gera o body da tabela
		foreach ($results as $question) {
			$qid = null;
			$courseid = SEOX_COURSE_ID;
			$vezes_usada = 0;
			$row = [];
			foreach ($question as $key => $field) {
				if ($key == 'seoxid') { 
					$qid = $field;
					continue; 
				}
				if ($key == 'qtype') { 
					//$qid = $field;
					continue; 
				}
				if ($key == 'dificuldade') {
					$row[] = \provacomp_buscaquestoes\form\buscaquestoes_form::$dificuldadeslist[$field];
					continue;
				}
				if ($key == 'qtext') {
					$field = strip_tags($field);
					$begin = (array_key_exists('text', $urldata)) ? strpos($field, $urldata['text']) : 0;
					$pre = ($begin > 0) ? '...' : '';
					$pos = ($begin + 60 < strlen($field)-1) ? '...' : '';
					$row[] = $pre . substr($field, $begin, 60) . $pos;
					continue;
				}
				if ($key == 'vezes_usada') {
					$vezes_usada = intval($field);
				}
				$row[] = $field;
			}

			// Actions Field
			// -- Preview
			$dropbuttom = $PAGE->get_renderer('mod_prova', 'estatisticas');
			$button = $dropbuttom->seox_add_menu_actions($qid);
			$last_column = '<div style="display:inline-block; width: 100px">';
			$previewurl = new moodle_url('/question/preview.php', array(
				'courseid' => $courseid,
				'id' => $qid,
			));
			$previewimage = $OUTPUT->pix_icon('t/preview', get_string('preview'), '', array('class' => 'iconsmall'));
    		$previewaction = new popup_action('click', $previewurl, 'questionpreview', array(
		        'height' => 600,
		        'width' => 800,
		    ));
			$last_column .= $OUTPUT->action_link($previewurl, $previewimage, $previewaction, array());

			if ($vezes_usada <= 0) {
				$returnurl = new moodle_url('/mod/prova/components/questions.php', $urldata);
				$returnurl = $returnurl->out_as_local_url(false);
				// -- Edit
				$editurl = new moodle_url('/mod/prova/components/addquestions/question.php', array(
					'courseid' => $courseid,
					'id' => $qid,
					'returnurl' => $returnurl,
				));
				$editaction = $OUTPUT->action_icon($editurl, new pix_icon('t/edit', get_string('edit')), null, array('class' => 'seox_leanblocks-action'));
				$last_column .= $editaction;

				// -- Delete
        		$deleteurl = new moodle_url('/mod/prova/components/buscaquestoes/deletequestion.php', array(
					'courseid' => $courseid,
        			'deleteselected' => $qid,
        			'q'.$qid => 1,
        			'sesskey' => sesskey(),
					'returnurl' => $returnurl,
        		));
    			$deleteaction = $OUTPUT->action_icon($deleteurl, new pix_icon('t/delete', get_string('delete')), null, array('class' => 'seox_leanblocks-action'));
				$last_column .= $deleteaction;
			}
			
			$row[] = $last_column . '</div>';

			$last_column = '<div style="display:inline-block; width: 100px">';
			$last_column .= $button;
			$row[] = $last_column . '</div>';

			$table->data[] = $row;
		}
		echo html_writer::table($table);
	} else {
		echo html_writer::tag('p', get_string('buscaquestoes:noresults_at_search', 'provacomp_buscaquestoes'));
	}
}