M.provacomp_buscaquestoes = M.provacomp_buscaquestoes || {};
var NS = M.provacomp_buscaquestoes.filtro_searchquestions = {};


NS.init = function(params) {
	if ('is_random' in params) {
		this.SELECTOR = {
			AREA: '#id_md_areas_random',
			SUBAREA: '#id_md_subareas_random',
			ASSUNTO: '#id_md_assuntos_random',
			DOM_AREA: 'id_md_areas_random',
			DOM_SUBAREA: 'id_md_subareas_random',
			DOM_ASSUNTO: 'id_md_assuntos_random',
		};
		this.params = params['default']['areas'];
	} else {
		this.SELECTOR = {
			AREA: '#id_md_areas',
			SUBAREA: '#id_md_subareas',
			ASSUNTO: '#id_md_assuntos',
			DOM_AREA: 'id_md_areas',
			DOM_SUBAREA: 'id_md_subareas',
			DOM_ASSUNTO: 'id_md_assuntos',
		};
		this.params = params;
	}
    Y.delegate('change', this.populateSubarea, Y.config.doc, NS.SELECTOR.AREA);
    Y.delegate('change', this.populateAssunto, Y.config.doc, NS.SELECTOR.SUBAREA);
    this.removeMissSelections();
};

NS.removeMissSelections = function() {
	var id_area = document.getElementById(NS.SELECTOR.DOM_AREA).value;
	var subarea = document.getElementById(NS.SELECTOR.DOM_SUBAREA);
	var assunto = document.getElementById(NS.SELECTOR.DOM_ASSUNTO);
	var subareaTarget = subarea.value;
	var assuntoTarget = assunto.value;

	subarea.innerHTML = '<option value="0"></option>';
	assunto.innerHTML = '<option value="0"></option>';

	if (id_area != 0) {
		var subareas = NS.params[id_area]['subareas'];
		Object.keys(subareas).map(function(index) {
			var o = new Option(subareas[index]['name'], index);
			subarea.appendChild(o);
			subarea.value = subareaTarget;
		});
	}
		
	if (subareaTarget != 0) {
		var assuntos = NS.params[id_area]['subareas'][subareaTarget]['assuntos'];
		Object.keys(assuntos).map(function(index) {
			var o = new Option(assuntos[index]['name'], index);
			assunto.appendChild(o);
			assunto.value = assuntoTarget;
		});
	}
}

NS.includeOptionsFiltroArea = function(target, target_jq) {
	Object.keys(target).map(function(index) {
		var o = new Option(target[index]['name'], index);
		target_jq.append(o);
	});
}

NS.populateSubarea = function(e) {
	var id_area = $(e.currentTarget._node).val();
	var subarea_jq = $(NS.SELECTOR.SUBAREA);
	var assunto_jq = $(NS.SELECTOR.ASSUNTO);
	subarea_jq.find('option').not('[value="0"]').remove();
	assunto_jq.find('option').not('[value="0"]').remove();

	if (id_area == 0) { return; }

	var subareas = NS.params[id_area]['subareas'];
	NS.includeOptionsFiltroArea(subareas, subarea_jq);
};

NS.populateAssunto = function(e) {
	var id_area = $(NS.SELECTOR.AREA).val();
	var id_subarea = $(e.currentTarget._node).val();
	var assunto_jq = $(NS.SELECTOR.ASSUNTO);
	assunto_jq.find('option').not('[value="0"]').remove();

	if (id_area == 0) { return; }
	if (id_subarea == 0) { return; }

	var assuntos = NS.params[id_area]['subareas'][id_subarea]['assuntos'];
	NS.includeOptionsFiltroArea(assuntos, assunto_jq);
};