<?php

$validation = readline("Você já fez o dump do seu DB? (y) or (n): ");
if ($validation != 'y') {
	die("Faça antes de executar esse script!\r\n");
}

echo "\r\n\r\n------ PRIMEIRA ETAPA ------\r\n";

define('CLI_SCRIPT', true);

require_once(__DIR__ . '/../../../config.php');


$sql = "SELECT qas.id, qas.questionattemptid, qas.sequencenumber, prova.prova as provaid
    FROM {question_attempt_steps} qas
    INNER JOIN {question_attempts} qa
    	ON qas.questionattemptid = qa.id 
    INNER JOIN {prova_attempts} prova
    	ON qa.questionusageid = prova.uniqueid
    WHERE qas.questionattemptid NOT IN (
    	SELECT questionattemptid
    	FROM {question_attempt_steps}
    	WHERE state IN ('mangrwrong', 'mangrright')
    	GROUP BY questionattemptid
    )
    ORDER BY qas.questionattemptid, qas.sequencenumber";

$attemts = $DB->get_records_sql($sql);

// array com objetos para deletar
$todelete = [];

// ultimo elemento da linha
$lastone = null;

// garente que todos as linhas sucessoras da com falha sejam deletadas
$hasfind = false;

foreach ($attemts as $value) {

	if ($lastone) {

		if ($lastone->questionattemptid == $value->questionattemptid) {

			if ($hasfind) {
				$todelete[] = $value;
			} else {
				$seq1 = $lastone->sequencenumber;
				$seq2 = $value->sequencenumber;

				if ($seq1 < $seq2 and $seq2 - $seq1 > 1) {
					$todelete[] = $value;
					$hasfind = true;
				}
			}
		} else {
			$hasfind = false;
		}

	}

	$lastone = $value;

}

print_r($todelete);
$validation = readline("\r\nAs linhas listadas acima serão deletadas da tabela question_attempt_steps. Devo prosseguir? (y) or (n): ");

if ($validation != 'y') { die ("Script interrompido\r\n"); }

echo "Essas foram as linhas da tabela question_attempt_steps deletadas:\n\r";

foreach ($todelete as $qstep_id) {
    //Deletar linha de um determinado attemptstepid
    $delete_step_data = $DB->delete_records('question_attempt_step_data', array('attemptstepid' => $qstep_id->id));

    //Deletar a linha de um determinado ID da tabela mdl_question_attempt_steps 
    $delete_attempt_steps = $DB->delete_records('question_attempt_steps', array('id' => $qstep_id->id));
}

print_r($todelete);
echo "\r\nAs linhas referentes a tabela question_attempt_step_data também foram deletadas.\n\r";



/**
 * Segundo passo
 */
echo "\r\n\r\n------ SEGUNDA ETAPA ------\r\n";
$validation = readline("Para garantir que não haja erros, será preciso marcar todos os attempts às provas que estão em progresso para serem validados pelo cronjob do plugin. Devo prosseguir? (y) or (n): ");

if ($validation != 'y') { die ("Script interrompido\r\n"); }

$query_update = $DB->execute("UPDATE {prova_attempts} SET timecheckstate = ? WHERE state = 'inprogress'", [time()]);

die("\r\n------ FIM DO SCRIPT ------\r\n\r\nAgora basta rodar o cronjob da pasta root do moodle:\n\r$ php admin/cli/cron.php\n\r\n\r");
