<?php
require_once(__DIR__ . '/../config.php');
require_once($CFG->dirroot . '/mod/prova/locallib.php');
require_once($CFG->dirroot . '/mod/prova/src/buscaprova/buscaprova_form.php');
$PAGE->set_context(context_system::instance());

$titleform = get_string('searchprovaaplicationtitle', 'prova');

\mod_prova\manager::has_permission_to_access();


$PAGE->set_url(new moodle_url('/mod/prova/screens/buscaprova/view.php'));
$PAGE->set_pagelayout('admin');

$PAGE->set_heading($titleform);
date_default_timezone_set('America/Sao_Paulo');
$title = 'Busca Provas';
$PAGE->set_title($title);

$toform = new stdClass;
$toform->md_name_prof = $USER->firstname;
$thisblock_form = new buscaprova_form();
$thisblock_form->set_data($toform);
$pagename = get_string('form_title', 'prova');

echo $OUTPUT->header();
echo html_writer::tag('h3', $pagename, null);
	echo '<br>';


/* print_r($thisblock_form->get_data());
exit; */

/*
 * Inicio tabela de aplicações
 */

if($thisblock_form->is_cancelled()) {
} else {
	// -------- LAST SEARCH AREA / Grab by url
	$get_last_search = array();
	if ($md_areas = optional_param('areas', 0, PARAM_INT)) {
		$get_last_search['md_areas'] = $md_areas;
	}
	if ($md_subareas = optional_param('subareas', 0, PARAM_INT)) {
		$get_last_search['md_subareas'] = $md_subareas;
	}
	 if ($md_assuntos = optional_param('assuntos', 0, PARAM_INT)) {
		$get_last_search['md_assuntos'] = $md_assuntos;
	} 
	if ($md_name_prova = optional_param('prova', null, PARAM_ALPHANUMEXT)) {
		$get_last_search['md_name_prova'] = $md_name_prova;
	}
	if ($md_name_prof = optional_param('prof', null, PARAM_ALPHANUMEXT)) {
		$get_last_search['md_name_prof'] = $md_name_prof;
	}


	// -------- FILTROS AREA
	if (!$thisblock_form->get_data() and !empty($get_last_search)) {
		$thisblock_form->populate_elements($get_last_search);
	}
	$thisblock_form->display();
	$PAGE->requires->yui_module(
		'moodle-provacomp_buscaprovas-filtro_searchquestions',
		'M.provacomp_buscaprovas.filtro_searchquestions.init',
		$thisblock_form->get_filtros_areas_content()
	);

	// -------- RESULT AREA
	$data = array();
	$urldata = array();
	if ($fromform = $thisblock_form->get_data() or
		(!empty($get_last_search) and $fromform = (Object) $get_last_search)) {

		if (array_key_exists('md_areas', $fromform) and $fromform->md_areas != 0) {
			$data[] = 'prova.id_area = '.$fromform->md_areas;
			$urldata['areas'] = $fromform->md_areas;
		}
		if (array_key_exists('md_subareas', $fromform) and $fromform->md_subareas != 0) {
			$data[] = 'prova.id_subarea = '.$fromform->md_subareas;
			$urldata['subareas'] = $fromform->md_subareas;
		}
		
		 if (array_key_exists('md_assuntos', $fromform) and $fromform->md_assuntos != 0) {
			$data[] = 'prova.id_assunto = '.$fromform->md_assuntos;
			$urldata['assuntos'] = $fromform->md_assuntos;
		} 
		if (array_key_exists('md_name_prova', $fromform) and $fromform->md_name_prova != '') {
			$data[] = "LOWER(prova_app.name) LIKE '%".strtolower($fromform->md_name_prova)."%'";
			$urldata['prova'] = $fromform->md_name_prova;
		}
		
		if (array_key_exists('timeopen', $fromform) and $fromform->timeopen != 0) {
			$data[] = 'prova_app.timeopen = '.$fromform->timeopen;
			$urldata['timeopen'] = $fromform->timeopen;
		} 
		if (array_key_exists('md_name_prof', $fromform) and $fromform->md_name_prof != '') {
			$data[] = "LOWER(users.firstname) LIKE '%".strtolower($fromform->md_name_prof)."%'";
			$urldata['prof'] = $fromform->md_name_prof;
		}
	
		
	}

}

print_table_seox($data, $urldata);

function print_table_seox($data, $urldata) {
	global $DB, $OUTPUT, $USER;

	if (!\mod_prova\manager::is_manager()) {
		$user_courses_ids = array_keys(enrol_get_my_courses("id"));
		$user_courses_ids = implode(",", $user_courses_ids);
		$courseValidation = $user_courses_ids && $user_courses_ids != '' ? "AND course.id IN ($user_courses_ids)" : null;

		if (!$courseValidation) {
			echo html_writer::tag('p', get_string('noresults_at_search', 'prova'));
			return;
		}
	} else {
		$courseValidation = null;
	}


	/* QUERY QUE NÂO TRAZ VAZIAS 
	SELECT prova.id, name, id_area, id_subarea, id_assunto, COUNT(slots.provaid) FROM mdl_seox_prova prova INNER JOIN mdl_seox_prova_slots slots ON prova.id = slots.provaid GROUP BY slots.provaid
	*/
	$sql = "SELECT 
			prova_app.cmid cmid,
			prova_app.id prova_appid,
			prova_app.attempts attempts,
			prova.id AS provaid,
			course.fullname as curso,
			concat(users.firstname,' ', users.lastname) AS prof_cad_app, 
			prova_app.name AS nome_aplic, 
			prova_app.timeopen AS data_hora_inicio_encoded,
			prova_app.timeclose AS data_hora_final_encoded,
			prova_app.corrected AS corrected
		FROM mdl_prova prova_app
		INNER JOIN mdl_seox_prova prova
		ON prova.id = prova_app.provaid
		INNER JOIN mdl_seox_prova_slots slots
		ON prova.id = slots.provaid
		INNER JOIN mdl_seox_area area
		ON prova.id_area = area.id
		INNER JOIN mdl_seox_subarea subarea
		ON prova.id_subarea = subarea.id
		INNER JOIN mdl_seox_assunto assunto
		ON prova.id_assunto = assunto.id
		INNER JOIN mdl_user users
		ON users.id = prova_app.userid
		JOIN mdl_course as course
		ON course.id = prova_app.course $courseValidation";


	if (!empty($data)) {
		$sql .= ' WHERE '.implode(' AND ', $data);
	} 

	$sql .= ' GROUP BY prova_app.id, prova.id, area.id, subarea.id, assunto.id, users.id, course.fullname
		ORDER BY prova_app.id DESC ';

	//Parametros para paginação
	$page = optional_param('page', 0, PARAM_INT);
	$perpage = 5;
	$start = $page * $perpage;
	
	//Query com dados paginados
	$results = $DB->get_records_sql($sql, null, $start, $perpage);
	$totalcount =  $DB->count_records('prova');
	

	// $table->head = array('Nome', 'Área', 'Subárea', 'Assunto', 'Dificuldade', 'Vezes Utilizada', 'Qtd de Questões', 'Ações');

	
	if (!empty($results)) {
		$table = new html_table();
		$table->head = array('Nome Aplic.', 'Curso', 'Prof. Cad. Aplic.', 'Data/Hora Inicio', 'Data/Hora Final', 'Ações', 'Correção');

		// Gera o body da tabela
		$cont = 1;
        
		foreach ($results as $prova) {
			$qid = null;
			//$courseid = SEOX_COURSE_ID;
			//$vezes_usada = $prova->vezes_usada;
			
			$data_hora_inicio	= format_date($prova->data_hora_inicio_encoded);
			$data_hora_final 	= format_date($prova->data_hora_final_encoded);
			$row = new html_table_row();
			$row->cells[] = $prova->nome_aplic;
			$row->cells[] = $prova->curso;
			$row->cells[] = $prova->prof_cad_app;
			$row->cells[] = ($data_hora_inicio != 0) ? $data_hora_inicio : ' - ';
			$row->cells[] = ($data_hora_final != 0) ? $data_hora_final : ' - ';

			// Actions Field
			// -- Preview
			$last_column = '<div style="display:inline-block; width: 100px">';
			$previewurl = new moodle_url('/mod/prova/components/addprovas/preview.php', array(
				'provaid' => $prova->provaid,
			));
			$previewimage = $OUTPUT->pix_icon('t/preview', get_string('preview'), '', array('class' => 'iconsmall'));
			$previewaction = new popup_action('click', $previewurl, 'questionpreview', array(
				'height' => 600,
				'width' => 800,
			));
			$last_column .= $OUTPUT->action_link($previewurl, $previewimage, $previewaction, array());
			$vezes_usada = 0;

			$returnurl = new moodle_url('/mod/prova/screens/buscaprova/view.php', $urldata);
			$returnurl = $returnurl->out_as_local_url(false);
			
			/* $returnurl = new moodle_url('/mod/prova/components/provas.php', array(
				'provaid' => $prova->provaid,
			));
			$returnurl = $returnurl->out_as_local_url(false); */

			$editurl = new moodle_url('/course/modedit.php', array(
				'update' => $prova->cmid,
				'returnurl' => $returnurl
			));
			$editaction = $OUTPUT->action_icon($editurl, new pix_icon('t/edit', get_string('edit')), null, array('class' => 'seox_leanblocks-action'));
			$last_column .= $editaction;

			/*Verifica na tabela se a prova em questão já teve alguma tentativa. 
			* Caso tenha, os botões editar e deletar não são exibidos. 
			* De outro modo eles são exibidos.
			*/
			$prova_attempts = $DB->record_exists('prova_attempts', array('prova'=> $prova->prova_appid));   

			if(!$prova_attempts){
				
				// -- Delete
				$deleteurl = new moodle_url('/course/mod.php', array(
					'sesskey' => sesskey(),	
					'delete' => $prova->cmid,
					'returnurl' => $returnurl
				));
				$deleteaction = $OUTPUT->action_icon($deleteurl, new pix_icon('t/delete', get_string('delete')), null, array('class' => 'seox_leanblocks-action'));
				$last_column .= $deleteaction; 

			}

			if($prova_attempts){
				// -- preview
				$listvieweurl = new moodle_url('/mod/prova/viewattempts.php', array(
					'appid' => $prova->prova_appid,
					'cm' => $prova->cmid,
					'returnurl' => $returnurl
				));
				$listviewaction = $OUTPUT->action_icon($listvieweurl, new pix_icon('t/viewdetails', get_string('preview')), null, array('class' => 'seox_leanblocks-action'));
				$last_column .= $listviewaction; 
			}

			$tbprova = $DB->get_record('prova', array('cmid'=>$prova->cmid), 'course', MUST_EXIST);
			$context = context_course::instance($tbprova->course);

			if($prova->corrected){
					// -- preview
					$listvieweurl = new moodle_url('/mod/prova/screens/report/report.php', array(
						'id' => $prova->cmid,
						'mode' => 'overview',
						'returnurl' => $returnurl
					));
					$listviewaction = $OUTPUT->action_icon($listvieweurl, new pix_icon('i/calendar', get_string('chartapp','prova')), null, array('class' => 'seox_leanblocks-action'));
					$last_column .= $listviewaction; 
			}
				
			$row->cells[] = $last_column . '</div>';
			$row->cells[] = render_report_button($prova->prova_appid);

			$table->data[] = $row;
			$cont++;
		}
		$url_default = new moodle_url('/mod/prova/screens/buscaprova/view.php', $urldata);
		$pagebar = $OUTPUT->paging_bar($totalcount, $page, $perpage, $url_default);
        echo $output = html_writer::table($table);
        echo $pagebar;
	} else {
		echo html_writer::tag('p', get_string('noresults_at_search', 'prova'));
	}
}

echo $OUTPUT->footer();

