<?php

$DB; $PAGE; $OUTPUT; $USER;

require_once('../../../../config.php');
require_once($CFG->dirroot . '/mod/prova/managelib.php');
require_once($CFG->dirroot . '/mod/prova/locallib.php');

$PAGE->set_context(context_system::instance());

\mod_prova\manager::has_permission_to_access_write();

$thisblock_form = new \mod_prova\form\seox_cad_area_form();

$url = new moodle_url('/mod/prova/screens/cad_area/edit.php');
$area_param = optional_param('area', null, PARAM_TEXT);
$update_param = optional_param('update', 0, PARAM_INT);

$PAGE->set_url($url);
$PAGE->set_pagelayout('admin');
$PAGE->set_heading(get_string('edit_area_form', 'prova'));
date_default_timezone_set('America/Sao_Paulo');
$title = 'Editar de Area';
$PAGE->set_title($title);
$userid = $USER->id;

// -------- LAST SEARCH AREA / Grab by url
$get_last_search = array();
if ($name_area_param = optional_param('area', 0, PARAM_TEXT)) {
	$get_last_search['md_areas'] = $name_area_param;
}

// -------- FILTROS AREA
if (!$thisblock_form->get_data() and !empty($get_last_search)) {
	$thisblock_form->populate_elements($get_last_search);
}

echo $OUTPUT->header();

//$param = (object) $get_last_search;
$toform = new stdClass();
$toform->update = $update_param;

$thisblock_form->set_data($toform);
$thisblock_form->display();
$data = array();
$urldata = array();

if ($fromform = $thisblock_form->get_data() /*or
	(!empty($get_last_search) and $fromform = (Object) $get_last_search)*/) {

	if (array_key_exists('md_areas', $fromform) and $fromform->md_areas != '') {
      		
            $data[] = $fromform->md_areas;
            $urldata['area'] = $fromform->md_areas;

            $update_areaobj = new stdClass();
            $update_areaobj->id = $fromform->update;
            $update_areaobj->name = $fromform->md_areas;
            $update_areaobj->usermodified = $userid;
            $update_areaobj->timemodified = time();

			$sucess = $DB->update_record('seox_area', $update_areaobj);
			if($sucess){
				//echo $OUTPUT->notification(get_string('update_area_sucess', 'prova'), 'notifysuccess');
				redirect_url(new moodle_url($url), 'Cadastro atualizado com sucesso!', 1);
			}else{
				echo $OUTPUT->notification(get_string('update_area_error', 'prova'), 'notifyerros');
			
			}
    }
    
	
}

print_table_seox($data, $urldata);

function print_table_seox($data, $urldata) {
	global $DB, $PAGE, $OUTPUT;
	// q.qtype AS qtype
	$sql = 'SELECT 
				area.id, area.name
        	FROM {seox_area} AS area';

    //Parametros para paginação
    $page = optional_param('page', 0, PARAM_INT);
    $perpage = 5;
    $start = $page * $perpage;

    //Query com dados paginados
    $results = $DB->get_records_sql($sql, null, $start, $perpage);
    //$results = $DB->get_records_sql($sql);
    $totalcount =  $DB->count_records('seox_area');

	if (!empty($results)) {
		$table = new html_table();
		$table->head = array('Nome da Área', 'Ações');

		// Gera o body da tabela
		foreach ($results as $question) {
			$qid = null;
			$courseid = SEOX_COURSE_ID;
			/* $vezes_usada = 0; */
			$row = [];
			foreach ($question as $key => $field) {
				 if ($key == 'id') { 
					$area_id = $field;
					continue; 
                }
                if ($key == 'name') { 
					$name_area = $field;
				}
                $row[] = $field;
			}

                $last_column = '<div style="display:inline-block; width: 50px">';
				$returnurl = new moodle_url('/mod/prova/screens/cad_area/view.php'/* , $urldata */);
				$returnurl = $returnurl->out_as_local_url(false);
				if(!$record_exists = $DB->record_exists('seox_prova', array('id_area'=>$area_id))){
				// -- Edit
				$editurl = new moodle_url('/mod/prova/screens/cad_area/edit.php', array(
					/* 'courseid' => $courseid, */
                    'area'=> $name_area,
                    'update'=>$area_id,
					/* 'returnurl' => $returnurl, */
				));
				$editaction = $OUTPUT->action_icon($editurl, new pix_icon('t/edit', get_string('edit')), null, array('class' => 'seox_leanblocks-action'));
				$last_column .= $editaction;

				// -- Delete
        		$deleteurl = new moodle_url('/mod/prova/screens/cad_area/deletearea.php', array(
					/* 'courseid' => $courseid, */
        			'deleteselected' => $area_id,
        			/* 'id'.$areaid => 1, */
        			'sesskey' => sesskey(),
					 'returnurl' => $returnurl, 
        		));
    			$deleteaction = $OUTPUT->action_icon($deleteurl, new pix_icon('t/delete', get_string('delete')), null, array('class' => 'seox_leanblocks-action'));
				$last_column .= $deleteaction;
			} 
			
            $row[] = $last_column . '</div>';
			$table->data[] = $row;
		}
		
		$url = new moodle_url('/mod/prova/screens/cad_area/edit.php', array(
			'area' => optional_param('area', null, PARAM_TEXT),
			'update'=> optional_param('update', 0, PARAM_INT),
		));
		$pagebar = $OUTPUT->paging_bar($totalcount, $page, $perpage, $url);
        echo $output = html_writer::table($table);
        echo $pagebar;
	} else {
		echo html_writer::tag('p', get_string('noresults_area', 'prova'));
	}
}

echo $OUTPUT->footer();