<?php

$DB; $PAGE; $OUTPUT; $USER;

require_once('../../../../config.php');
require_once($CFG->dirroot . '/mod/prova/managelib.php');
require_once($CFG->dirroot . '/mod/prova/locallib.php');

$PAGE->set_context(context_system::instance());

\mod_prova\manager::has_permission_to_access_write();

$thisblock_form = new \mod_prova\form\seox_cad_assunto_form();

$url = new moodle_url('/mod/prova/screens/cad_assunto/view.php');
$update_param = optional_param('update', 0, PARAM_INT);
$assunto_param = optional_param('assunto', null, PARAM_TEXT);
$originalreturnurl = optional_param('returnurl', 0, PARAM_URL);

$PAGE->set_url($url);
$PAGE->set_pagelayout('admin');
$PAGE->set_heading(get_string('cad_assunto_form', 'prova'));
date_default_timezone_set('America/Sao_Paulo');
$title = 'Cadastro de Assunto';
$PAGE->set_title($title);
$userid = $USER->id;

// -------- LAST SEARCH AREA / Grab by url
$get_last_search = array();
if ($name_area_param = optional_param('area', 0, PARAM_INT)) {
	$get_last_search['md_areas'] = $name_area_param;
}
if ($name_subarea_param = optional_param('subarea', 0, PARAM_INT)) {
	$get_last_search['md_subareas'] = $name_subarea_param;
}
if ($name_assunto_param = optional_param('assunto', 0, PARAM_TEXT)) {
	$get_last_search['md_assuntos'] = $name_assunto_param;
}

// -------- FILTROS AREA
if (!$thisblock_form->get_data() and !empty($get_last_search)) {
	$thisblock_form->populate_elements($get_last_search);
}
$PAGE->requires->css('/mod/prova/buttonselectcad.css');
echo $OUTPUT->header();
$toform = new stdClass();
$toform->returnurl = $originalreturnurl;
$thisblock_form->set_data($toform);

$thisblock_form->display();
$PAGE->requires->yui_module(
	'moodle-provacomp_buscaquestoes-filtro_searchquestions',
	'M.provacomp_buscaquestoes.filtro_searchquestions.init',
	$thisblock_form->get_filtros_areas_content()
);
$data = array();
$urldata = array();

//Insert: Quando o form for submitido entra neste IF
if ($fromform = $thisblock_form->get_data() /*or
	(!empty($get_last_search) and $fromform = (Object) $get_last_search)*/) {
		
	if (array_key_exists('md_assuntos', $fromform) and $fromform->md_assuntos != '') {

            $data[] = $fromform->md_areas;
            $urldata['assunto'] = $fromform->md_assuntos;

            $areaobj = new stdClass();
            $areaobj->id_subarea = $fromform->md_subareas;
            $areaobj->name = $fromform->md_assuntos;
            $areaobj->usermodified = $userid;
			$areaobj->timecreated = time();
    
			$DB->insert_record('seox_assunto', $areaobj);
			if ($fromform->returnurl) {
				redirect_url(new moodle_url($fromform->returnurl), 'Redirecionando...', 1);
		  	}else{
				redirect_url(new moodle_url($url), 'Cadastro realizado com sucesso!', 1);
		  }
			
    }
}

print_table_seox($data, $urldata);

function print_table_seox($data, $urldata) {
    global $DB, $PAGE, $OUTPUT;
    $url = new moodle_url('/mod/prova/screens/cad_assunto/view.php');
	// q.qtype AS qtype
	$sql = 'SELECT 	assunto.id, subarea.id AS subarea_id,
					area.id AS area_id, 
					assunto.name AS assunto_nome, 
					subarea.name as subarea_nome, 
					area.name as area_nome
			FROM {seox_assunto} AS assunto
			INNER JOIN {seox_subarea} AS subarea
			ON subarea.id = assunto.id_subarea
			INNER JOIN {seox_area} AS area
			ON area.id = subarea.id_area';

    //Parametros para paginação
    $page = optional_param('page', 0, PARAM_INT);
    $perpage = 5;
    $start = $page * $perpage;

    //Query com dados paginados
    $results = $DB->get_records_sql($sql, null, $start, $perpage);
    $totalcount =  $DB->count_records('seox_assunto');

	if (!empty($results)) {
		$table = new html_table();
		$table->head = array('Nome da Assunto', 'Subarea', 'Área', 'Ações');

		// Gera o body da tabela
		foreach ($results as $question) {
			$qid = null;
			$courseid = SEOX_COURSE_ID;
			/* $vezes_usada = 0; */
			$row = [];
			foreach ($question as $key => $field) {
				 if ($key == 'subarea_id') { 
					$subarea_id = $field;
					continue; 
                }
				 if ($key == 'area_id') { 
					$area_id = $field;
					continue; 
                }
				 if ($key == 'id') { 
					$assunto_id = $field;
					continue; 
                }
                if ($key == 'assunto_nome') { 
					$name_assunto = $field;
				}
                $row[] = $field;
			}
			
                $last_column = '<div style="display:inline-block; width: 50px">';
				$returnurl = new moodle_url('/mod/prova/screens/cad_assunto/view.php'/* , $urldata */);
                $returnurl = $returnurl->out_as_local_url(false);

                if(!$record_exists = $DB->record_exists('seox_prova', array('id_assunto'=>$assunto_id))){
				// -- Edit
				$editurl = new moodle_url('/mod/prova/screens/cad_assunto/edit.php', array(
					/* 'courseid' => $courseid, */
                    'area'=> $area_id,
                    'subarea'=> $subarea_id,
                    'assunto'=> $name_assunto,
                    'update'=> $assunto_id,
					/* 'returnurl' => $returnurl, */
				));
				$editaction = $OUTPUT->action_icon($editurl, new pix_icon('t/edit', get_string('edit')), null, array('class' => 'seox_leanblocks-action'));
				$last_column .= $editaction;

				// -- Delete
        		$deleteurl = new moodle_url('/mod/prova/screens/cad_assunto/deleteassunto.php', array(
					/* 'courseid' => $courseid, */
        			'deleteselected' => $assunto_id,
        			/* 'id'.$areaid => 1, */
        			'sesskey' => sesskey(),
					'returnurl' => $returnurl,
        		));
    			$deleteaction = $OUTPUT->action_icon($deleteurl, new pix_icon('t/delete', get_string('delete')), null, array('class' => 'seox_leanblocks-action'));
				$last_column .= $deleteaction;
			 } 
			
            $row[] = $last_column . '</div>';
			$table->data[] = $row;
        }
        
        $pagebar = $OUTPUT->paging_bar($totalcount, $page, $perpage, $url);
        echo $output = html_writer::table($table);
        echo $pagebar;
	} else {
		echo html_writer::tag('p', get_string('noresults_assunto', 'prova'));
	}
}

echo $OUTPUT->footer();