<?php
/**
 * Este arquivo usa como base funções dentro do moodle
 * que envolvam a deleção de uma subarea. 
 */ 
require_once('../../../../config.php');
require_once($CFG->dirroot . '/lib/questionlib.php');

use \provacomp_buscaquestoes\action\buscaquestoes_actions as Custom_actions;

\mod_prova\manager::has_permission_to_access_write();

$PAGE->set_context(context_system::instance());
$PAGE->set_url(new moodle_url('/mod/prova/screens/cad_subarea/deletesubarea.php'));
$pagename = get_string('deletesubarea_title', 'prova');
$PAGE->set_title($pagename);
$PAGE->set_heading($pagename);
$PAGE->set_pagelayout('admin');
$PAGE->navbar->add($pagename);

if (($confirm = optional_param('confirm', '', PARAM_ALPHANUM)) and confirm_sesskey()) {
    $deleteselected = required_param('deleteselected', PARAM_INT);
    if ($confirm == md5($deleteselected)) {

        $DB->delete_records('seox_subarea', array('id' => $deleteselected));
        redirect(required_param('returnurl', PARAM_LOCALURL));
    } else {
        print_error('invalidconfirmsubarea', 'prova');
    }
}

$subareaid = required_param('deleteselected', PARAM_INT);
//$courseid = required_param('courseid', PARAM_INT);
$returnurl = new moodle_url(required_param('returnurl', PARAM_LOCALURL));

//Custom_actions::question_availability($questionid);

if (!$subarea = $DB->get_record('seox_subarea', array('id' => $subareaid))) {
    print_error('invalidconfirmsubarea', 'prova', $returnurl);
}

$params = array(
    //'deleted' => $area->name,
    'returnurl' => $returnurl,
);
$cancellUrl = new moodle_url($returnurl, $params);
$baseurl = new moodle_url('deletesubarea.php', $params);
$deleteurl = new moodle_url($baseurl, array(
    'deleteselected' => $subareaid,
    'confirm' => md5($subareaid),
    'sesskey' => sesskey())
);

$continue = new single_button($deleteurl, get_string('delete'), 'post');
echo $OUTPUT->header();
echo $OUTPUT->confirm(get_string('delete_subarea', 'prova', $subarea->name), $continue, $cancellUrl);
echo $OUTPUT->footer();