<?php

require_once('../../../../config.php');
require_once('../../src/estatisticasquestao/filter_statics_form.php');
require_once($CFG->dirroot . '/mod/prova/lib.php');
$PAGE->set_context(context_system::instance());

require_login();

\mod_prova\manager::has_permission_to_access();

$thisblock_form = new filter_statics_form();
$questionid = optional_param('id', null, PARAM_INT);

global $PAGE, $DB;


$PAGE->set_url(new moodle_url('/mod/prova/screens/estatisticasquestao/chartdifficulty.php', array('id' => $questionid)));
$PAGE->set_heading('Variação no Nível de Dificuldade da Questão');
$PAGE->set_pagelayout('admin');
$PAGE->requires->css('/mod/prova/src/estatisticasquestao/filter_difficulty.css');
$pagename = get_string('form_title_statistic_header', 'prova');
$title = get_string('form_title_statistic', 'prova');
$PAGE->set_title($title);
$PAGE->requires->css('/mod/prova/src/estatisticasquestao/filter_buttons.css');
date_default_timezone_set('America/Sao_Paulo');

echo $OUTPUT->header();
echo html_writer::tag('h3', $pagename, null);
echo '<br>';

$return = new moodle_url('/mod/prova/screens/estatisticasquestao/view.php');
$thisblock_form->display();

$button = new single_button($return, get_string('cancel', 'prova'), 'get', true);
echo $OUTPUT->render($button);

/*Quando é exibida elá entra neste IF*/
if (!$fromform = $thisblock_form->get_data()){


/*Query que mostra a variação da dificuldade
* da questão nos ultimos 3 meses*/

$sql = "SELECT  qdiff.id, qdiff.dificuldade, qdiff.questionid,  assunto.name AS nome, qdiff.timemodified
        FROM  {seox_questions_difficulty} AS qdiff
        JOIN {seox_questions} AS questions
        ON questions.id_question = qdiff.questionid
        JOIN {seox_assunto} AS assunto
        ON questions.id_assunto = assunto.id
        WHERE qdiff.questionid =  $questionid
        ORDER BY qdiff.timemodified";

        $results = $DB->get_records_sql($sql);

        if(!$results){
            $warningtextform = html_writer::tag('p', get_string('warningtextquery', 'prova'));
            $warningbody = html_writer::tag('span', $warningtextform, array('id' => 'warningselectprova'));
            echo $warningbody; 
        }

        $date = new DateTime();

        $mesAtual = date('m'); 
        /* $trimestre = $mesAtual - 3;  
        $trimestre = new DateTime('+1 month'); */
        $trimestre = date('m', strtotime('-3 month'));
        
        $nameQuestion = '';
        $arrayDificuldade[] = '';
        $arrayLabels[] = '';

        if($results){
               
            foreach ($results as $key => $value) {

                $date->setTimestamp($value->timemodified);
                $dataQuery = $date->format('m');
                
                //if($dataQuery > $trimestre && $dataQuery <= $mesAtual){
                    
                    $arrayDificuldade[] = $value->dificuldade + 1;
                    $arrayLabels[]= $date->format('d-M-Y');
               // } 
            }

            $nameQuestion = $value->nome;
        }
        
   /*Quando o filter form for submitido entra neste IF 
   OBS: Todos os itens do form precisam ser preenchidos*/ 
} elseif ($fromform = $thisblock_form->get_data()) {

    		
		 if (array_key_exists('md_date_init', $fromform) and $fromform->md_date_init != 0) {
			$fromform->md_date_init;
        } 
        
		 if (array_key_exists('md_date_finish', $fromform) and $fromform->md_date_finish != 0) {
            $fromform->md_date_finish;
		} 

        $sql = "SELECT  qdiff.dificuldade, qdiff.questionid,  
                        assunto.name AS nome, qdiff.timemodified
                FROM  {seox_questions_difficulty} AS qdiff
                JOIN {seox_questions} AS questions
                ON questions.id_question = qdiff.questionid
                JOIN {seox_assunto} AS assunto
                ON questions.id_assunto = assunto.id
                WHERE qdiff.questionid = $fromform->questionid
                ORDER BY qdiff.timemodified";

        
        $results = $DB->get_records_sql($sql);

        if(!$results){
            $warningtextform = html_writer::tag('p', get_string('warningtextquery', 'prova'));
            $warningbody = html_writer::tag('span', $warningtextform, array('id' => 'warningselectprova'));
            echo $warningbody; 
        }

        $date = new DateTime();
        $dateInit = new DateTime();
        $dateFinish = new DateTime();

        $dateInit->setTimestamp($fromform->md_date_init);
        $dateFinish->setTimestamp($fromform->md_date_finish);

        $dataInicial = $dateInit->format('m-Y');
        $dataFinal = $dateFinish->format('m-Y');

        $nameQuestion = '';
        $arrayDificuldade[] = '';
        $arrayLabels[] = '';

        if($results){
               
            foreach ($results as $key => $value) {

                $date->setTimestamp($value->timemodified);
                $dataQuery = $date->format('m-Y');
                
                if($dataQuery <= $dataInicial || $dataQuery <= $dataFinal){
                    
                    $arrayDificuldade[] = $value->dificuldade + 1;
                    $arrayLabels[]= $date->format('d-M-Y');
                } 
            }

            $nameQuestion = $value->nome;
        }
       
    }


    $sales = new \core\chart_series($nameQuestion, $arrayDificuldade);
    $labels = $arrayLabels;

    $chart = new \core\chart_line();
    $chart->set_smooth(true);
    $chart->set_title('N. Dificuldade: (de 1 até 1,5) = Fácil;  (de 1,5 até 2,2) = Médio;  (de 2,2 até 3) = Dificil');  
    $chart->add_series($sales);
    $chart->set_labels($labels);
    
    if($results){
        
        /*Renderiza o Gráfico que será exibido na página*/
        echo $OUTPUT->render($chart);
    }
    

echo $OUTPUT->footer();