<?php

require_once('../../../../config.php');
require_once('../../src/estatisticasquestao/filter_statics_form.php');
require_once($CFG->dirroot . '/mod/prova/lib.php');
$PAGE->set_context(context_system::instance());

require_login();

\mod_prova\manager::has_permission_to_access();

$thisblock_form = new filter_statics_form();
$questionid = optional_param('id', null, PARAM_INT);

global $PAGE, $DB;
$originalreturnurl = optional_param('returnurl', 0, PARAM_LOCALURL);

$PAGE->set_url(new moodle_url('/mod/prova/screens/estatisticasquestao/chartquestion.php', array('id' => $questionid)));
$PAGE->set_title('Estatisticas de Questão');
$PAGE->set_heading('Nº de Vezes Que a Questão Foi Respondida');
$PAGE->set_pagelayout('admin');
$PAGE->requires->css('/mod/prova/src/estatisticasquestao/filter.css');
$pagename = get_string('form_title_statistic_header', 'prova');
$title = get_string('form_title_statistic', 'prova');
$PAGE->set_title($title);
$PAGE->requires->css('/mod/prova/src/estatisticasquestao/filter_buttons.css');
date_default_timezone_set('America/Sao_Paulo');

echo $OUTPUT->header();
echo html_writer::tag('h3', $pagename, null);
echo '<br>';

if($originalreturnurl !== 0){
    $returnurl = new moodle_url($originalreturnurl);
}else{
    $returnurl = new moodle_url('/mod/prova/screens/estatisticasquestao/view.php');
}

// vairavel que permite somente exibir uma questao
$WARNINGS = []; 

$thisblock_form->display();

$button = new single_button($returnurl, get_string('cancel', 'prova'), 'get');

echo $OUTPUT->render($button);
$nomes = [];
$corretas = [];
$incorretas = [];

/*Quando é exibida elá entra neste IF*/
if (!$fromform = $thisblock_form->get_data()){

    //Pegar o id da prova (provaid) passando como parametro o id da questão (questionid) recebido por url
    $provaid = $DB->get_records('seox_prova_slots', array('questionid' => $questionid), null, 'provaid');


    if($provaid){

        $array_provaid = [];
        foreach ($provaid as $key => $prova_id) {  
            $array_provaid[] = $prova_id->provaid;
        }

        //Pega o ID e o nome da aplicação de prova passando como parametro o provaid obtido da variavel $provaid
        $list_provaid = implode("," , $array_provaid);

        $query = "  SELECT id, name
                    FROM {prova}
                    WHERE provaid IN ($list_provaid)"; 
        $prova_appid = $DB->get_records_sql($query);

        $array_prova_app = [];
        foreach ($prova_appid as $key => $prova_app) {  
            $array_prova_app[] = $prova_app->id;
        }

        if (empty($array_prova_app)) {
            print_normal_warning();
        }

        //Pegar o campo uniqueid passando como parametro o ID da aplicação de prova (prova) obtido da variavel $prova_appid
        foreach ($array_prova_app as $key => $prova_app) {

            $prova_uniqueid = $DB->get_records('prova_attempts', array('prova' => $prova_app), null, 'uniqueid'); 
            $array_prova_uniqueid = [];
            foreach ($prova_uniqueid as $key => $prova_uid) {
                $array_prova_uniqueid[intval($prova_app)][] = $prova_uid->uniqueid;
            }

            if (empty($array_prova_uniqueid)) {
                $WARNINGS[] = $prova_app;
                continue;
            }

            $list_uniqueid = implode("," , $array_prova_uniqueid[$prova_app]);

            $query_quest_attempts = "SELECT MAX(rootsteps.id) AS stepid
                        FROM {question_attempts} AS qatt
                        INNER JOIN {question_attempt_steps} rootsteps
                        ON rootsteps.questionattemptid = qatt.id
                        WHERE rootsteps.state IN ('gradedright', 'mangrright', 'gradedwrong', 'mangrwrong')
                            AND qatt.questionusageid IN ($list_uniqueid) AND qatt.questionid = $questionid GROUP BY rootsteps.questionattemptid"; 
            $question_attempts_results = $DB->get_records_sql($query_quest_attempts);

            $array_quest_att_ids = [];
            foreach ($question_attempts_results as $key => $quest_att_id) {
                $array_quest_att_ids[intval($prova_app)][] = $quest_att_id->stepid;
            } 

            if (empty($array_quest_att_ids)) {
                $WARNINGS[] = $prova_app;
                continue;
            }
            
            $list_quest_att_ids = implode("," , $array_quest_att_ids[$prova_app]);

            /*This query returns all quiz applications that
            * contains the question passed by the url id parameter*/

            $sqlchart = "SELECT prova.name AS nome_app, 
                        COUNT( CASE WHEN (qatt_steps.state = 'gradedright' OR qatt_steps.state = 'mangrright') THEN 1  END ) AS R_Corretas,
                        COUNT( CASE WHEN (qatt_steps.state = 'gradedwrong' OR qatt_steps.state = 'mangrwrong') THEN 1  END ) AS R_Incorretas
                    FROM {question_attempt_steps} as qatt_steps
                    JOIN {question_attempts} AS qatt 
                    ON qatt_steps.questionattemptid = qatt.id
                    JOIN {prova_attempts} AS prova_att 
                    ON prova_att.uniqueid = qatt.questionusageid
                    JOIN {prova} AS prova 
                    ON prova.id = prova_att.prova
                    WHERE qatt_steps.id IN ($list_quest_att_ids) GROUP BY prova.name";


            $results_chart = $DB->get_records_sql($sqlchart); 

            if(!$results_chart OR !end($results_chart)->nome_app){
                $WARNINGS[] = $prova_app;
            } 
            /*Array that contains the labels and values ​​that will be used in the chart.*/
            else {
                foreach ($results_chart as $key => $dados_prova_app) {
                    $nomes[] = $dados_prova_app->nome_app;
                    $corretas[] = $dados_prova_app->r_corretas;
                    $incorretas[] = $dados_prova_app->r_incorretas;
                }
            }
        }

    }else{

        $nomes = [];
        $corretas = [];
        $incorretas = [];
        print_normal_warning();
    }
    
   /*Quando o filter form for submitido entra neste IF 
   OBS: Todos os itens do form precisam ser preenchidos*/ 
} elseif ($fromform = $thisblock_form->get_data()) {

    $data = array();
    $dateInit = new DateTime();
    $dateFinish = new DateTime();
    $formDateInit = new DateTime();
    $formDateFinish = new DateTime();
                 
	if (array_key_exists('md_prof', $fromform) and $fromform->md_prof != 0) {
		$data[] = 'prova.userid = '.$fromform->md_prof;
	}
	if (array_key_exists('md_curso', $fromform) and $fromform->md_curso != 0) {
		$data[] = 'prova.course = '.$fromform->md_curso;
	}
	
	if (array_key_exists('md_date_init', $fromform) and $fromform->md_date_init != 0) {
        $formDateInit->setTimestamp($fromform->md_date_init);
    } 
    
	if (array_key_exists('md_date_finish', $fromform) and $fromform->md_date_finish != 0) {
        $formDateFinish->setTimestamp($fromform->md_date_finish);
    } 

    //Inicio novo codigo

    //Pegar o id da prova (provaid) passando como parametro o id da questão (questionid) recebido por url
    $provaid = $DB->get_records('seox_prova_slots', array('questionid' => $fromform->questionid),null, 'provaid');
    
    if($provaid){

        foreach ($provaid as $key => $prova_id) {  
            $array_provaid[] = $prova_id->provaid;
        }

        //Pega o ID e o nome da aplicação de prova passando como parametro o provaid obtido da variavel $provaid
        $list_provaid = implode("," , $array_provaid);

        $query = "SELECT prova.id, prova.name
                    FROM {prova} as prova
                    WHERE prova.provaid IN ($list_provaid)";

        $query .= $data ? ' AND ' .implode(' AND ', $data) : '';
        
        $prova_appid = $DB->get_records_sql($query);

        $array_prova_app = [];
        foreach ($prova_appid as $key => $prova_app) {  
            $array_prova_app[] = $prova_app->id;
        }

         if (empty($array_prova_app)) {
            print_normal_warning();
        }

        //Pegar o campo uniqueid passando como parametro o ID da aplicação de prova (prova) obtido da variavel $prova_appid
        foreach ($array_prova_app as $key => $prova_app) {

            $prova_uniqueid = $DB->get_records('prova_attempts', array('prova' => $prova_app), null, 'uniqueid'); 

            $array_prova_uniqueid = [];
            foreach ($prova_uniqueid as $key => $prova_uid) {
                $array_prova_uniqueid[intval($prova_app)][] = $prova_uid->uniqueid;
            }
            
            if (empty($array_prova_uniqueid)) {
                $WARNINGS[] = $prova_app;
                continue;
            }
            
            $list_uniqueid = implode("," , $array_prova_uniqueid[$prova_app]);

            $query_quest_attempts = "SELECT MAX(rootsteps.id) AS stepid
                FROM {question_attempts} AS qatt
                INNER JOIN {question_attempt_steps} rootsteps
                ON rootsteps.questionattemptid = qatt.id
                WHERE rootsteps.state IN ('gradedright', 'mangrright', 'gradedwrong', 'mangrwrong')
                    AND qatt.questionusageid IN ($list_uniqueid) AND qatt.questionid = $fromform->questionid 
                    GROUP BY rootsteps.questionattemptid"; 
            $question_attempts_results = $DB->get_records_sql($query_quest_attempts);

            $array_quest_att_ids = [];
            foreach ($question_attempts_results as $key => $quest_att_id) {
                $array_quest_att_ids[intval($prova_app)][] = $quest_att_id->stepid;
            }

            if (empty($array_quest_att_ids)) {
                $WARNINGS[] = $prova_app;
                continue;
            }
            
            $list_quest_att_ids = implode("," , $array_quest_att_ids[$prova_app]);

            //fim novo codigo      
        
            $sql_chart_filter = "SELECT prova.cmid AS cmid, 
                        prova.userid AS usersid, prova.course AS course, 
                        prova.name AS nome_app, qatt.questionid AS questionid,
                        COUNT( CASE WHEN (qatt_steps.state = 'gradedright' OR qatt_steps.state = 'mangrright') THEN 1  END ) AS R_Corretas,
                        COUNT( CASE WHEN (qatt_steps.state = 'gradedwrong' OR qatt_steps.state = 'mangrwrong') THEN 1  END ) AS R_Incorretas,
                        timeopen,
                        timeclose
                    FROM {question_attempt_steps} as qatt_steps
                    JOIN {question_attempts} AS qatt 
                    ON qatt_steps.questionattemptid = qatt.id
                    JOIN {prova_attempts} AS prova_att 
                    ON prova_att.uniqueid = qatt.questionusageid
                    JOIN {prova} AS prova 
                    ON prova.id = prova_att.prova
                    WHERE qatt_steps.id IN ($list_quest_att_ids)";
            
            $sql_chart_filter .= 'GROUP BY course, nome_app, questionid, timeopen, timeclose, cmid, usersid'; 

            $results_chart_filter = $DB->get_records_sql($sql_chart_filter);

            if(!$results_chart_filter OR !end($results_chart_filter)->nome_app){
                $WARNINGS[] = $prova_app;
            }
            /*Array that contains the labels and values ​​that will be used in the chart.*/
            else {
                if ($fromform->md_date_init != 0 and $fromform->md_date_finish !=0){

                    foreach ($results_chart_filter as $key => $value) {
                        $dateInit->setTimestamp($value->timeopen);
                        $dateFinish->setTimestamp($value->timeclose); 
                        if($dateInit->format('m-Y') == $formDateInit->format('m-Y') and $dateFinish->format('m-Y') == $formDateFinish->format('m-Y')){
                            $nomes[] = $value->nome_app;
                            $corretas[] = $value->r_corretas;
                            $incorretas[] = $value->r_incorretas;
                        }
                    }

                }else{
                    
                    foreach ($results_chart_filter as $key => $value) {
                        $nomes[] = $value->nome_app;
                        $corretas[] = $value->r_corretas;
                        $incorretas[] = $value->r_incorretas;
                    }
                }
                
            }
        }
    }else{

        $nomes = [];
        $corretas = [];
        $incorretas = [];
        print_normal_warning();
    }
}

print_warning();
    
/*Variaveis que instanciam um objeto chart_series. 
Este objeto recebe como parametro uma string (legenda) e um array de valores
que serão exibidos quando o mouse passar sobre a barra do gráfico */

$questions_correct = new \core\chart_series('Corretas', $corretas);
$questions_incorrects = new \core\chart_series('Incorretas', $incorretas);

/*Labels que são exibidos como legenda acima do gráfico*/
$labels = $nomes;
    
/*Instancia um objeto chart_bar e adiciona as series e labels*/
$chart = new core\chart_bar();
$chart->add_series($questions_correct);
$chart->add_series($questions_incorrects);
$chart->set_labels($labels);

/*Renderiza o Gráfico que será exibido na página*/
echo $OUTPUT->render($chart);
echo $OUTPUT->footer();

function print_normal_warning() {
    global $WARNINGS;
    $WARNINGS = [];
    $warningtextform = html_writer::tag('p', get_string('warningtextquery', 'prova'));
    $warningbody = html_writer::tag('span', $warningtextform, array('id' => 'warningselectprova'));
    echo $warningbody; 
}

function print_warning() {
    global $WARNINGS;
    if (empty($WARNINGS)) { return; }

    $warns = implode(', ', $WARNINGS);
    $warningtextform = html_writer::tag('p', get_string('warningtextquery_question', 'prova', $warns));
    $warningbody = html_writer::tag('span', $warningtextform, array('id' => 'warningselectprova'));
    echo $warningbody; 
}