<?php
/**
 * This page deals with processing reports during the prova correction.
 *
 * Geralmente utilizado para disponibilizar as notas aos alunos.
 *
 * @package mod_prova
 */

require_once(__DIR__ . '/../config.php');
require_once($CFG->dirroot . '/mod/prova/locallib.php');


$provaid = required_param('provaid',  PARAM_INT);
$returnurl = optional_param('returnurl', null, PARAM_LOCALURL);
$noattempts = optional_param('noatttempts', false, PARAM_INT);

$provaobj = prova::create($provaid, $USER->id);

// Check login.
require_login($provaobj->get_course(), false, $provaobj->get_cm());
require_sesskey();

$qids = $provaobj->get_questionids();
$currentIdDiffs = [];
foreach ($qids as $id) {
	$value = optional_param('q'.$id, null, PARAM_NUMBER);
	$qa = optional_param('q'.$id.'-qa', null, PARAM_NUMBER);
	$qr = optional_param('q'.$id.'-qr', null, PARAM_NUMBER);

	if (!$value && $value !== 0) { continue; }
	if (!$qa && $qa !== 0) { continue; }
	if (!$qr) { continue; }

	$currentIdDiffs[$id]['questionid'] = $id;
	$currentIdDiffs[$id]['value'] = $value;
	$currentIdDiffs[$id]['qa'] = $qa;
	$currentIdDiffs[$id]['qr'] = $qr;
}


// Pega a ultima dificuldade da questão com base no calculo
//      -- fácil = 0
//      -- medio = 1
//      -- dificil = 2
// inserir var uma linha para cada questõa na tabela seox_questions_difficulty
//		-- questionid
// 		-- dificuldade
// 		-- QA
// 		-- QR
//		-- timemodified
// Atualizar dificuldade da questão na tabela seox_questions


if (!$noattempts) {
	update_questions_difficulties($currentIdDiffs);
	$provaobj->set_corrected_status();
}

if ($returnurl) {
    redirect($returnurl);
} else {
    redirect(new moodle_url('/mod/prova/screens/report/report.php', array('q' => $provaid, 'mode' => 'responses')));
}