YUI.add('moodle-mod_prova-provacontrol', function (Y, NAME) {

/**
 * Auto-save functionality for during quiz attempts.
 *
 * @module moodle-mod_prova-provacontrol
 */

/**
 * Auto-save functionality for during quiz attempts.
 *
 * @class M.mod_prova.provacontrol
 */

M.mod_prova = M.mod_prova || {};
M.mod_prova.provacontrol = {

	PROVACONTROL_HANDLER: M.cfg.wwwroot + '/mod/prova/ajax/provacontrol.ajax.php',

    SELECTORS: {
        PROVACONTROL_FORM: '#provacontrol',
    },
    
    init: function(params) {
        this.form = Y.one(this.SELECTORS.PROVACONTROL_FORM);
        this.returnurl = params.url;
        this.alertMsg = params.msg;
       	setInterval(this.checkPageFocus, 300);
    },

    triggerControlAction: function() {
        if (!this.processing) {
            setTimeout(function(self) {
                if (!document.hasFocus()) {
                	Y.io(self.PROVACONTROL_HANDLER, {
                        method:  'POST',
                        form:    {id: self.form},
                        on:      {
                            success: self.closeProva,
                            failure: self.failed
                        },
                        context: self
                    });
                } else {
                    self.processing = false;
                }
            }, 2000, this);

            this.processing = true;
        }
    },

    closeProva: function(response, data) {
    	if (!this.closed) {
            alert(this.alertMsg);
	    	setTimeout(function() {
	            if (window.opener) {
	                window.opener.document.location.reload();
	                window.close();
	            } else {
	                window.location.href = this.returnurl;
	            }
	        }, 300);
	        this.closed = true;
	    }
    },

    failed: function(failure) {
    	this.processing = false;
    },

    checkPageFocus: function() {
        if (!document.hasFocus()) {
           M.mod_prova.provacontrol.triggerControlAction();
        }
    },

};


}, '@VERSION@', {"requires": ["base", "node", "io-form"]});
